clear all
clc
for i=1:1
Comp=i;
for j=1:1
CONVswitch=j;
for k=1:1
Tlswitch=k;
for l=1:1
diffmodel=l;

 global N  GASCONST MMASS
tic
% Comp
% CONVswitch
% Tlswitch
% diffmodel
% pause

%For loops:
% i = main component
% j = secondary component
% k = position in particle

%convective on off
% ConvSWITCH=1;% on=1 off=0

%BC - transfer limitations on off
% TlSWITCH=1;

%Diffusion model
% DIFFmodel=1;
%1=Wilke
%2=Wilke Bosanquet
%3=MS
%4=Dusty gas

%component solved by 1-sum(N-1)
% CompSOLV=1;
%1=CH4
%2=CO2
%3=CO
%4=H2
%5=N2
%6=H2O

    if Comp==1
        constantH2O
    elseif Comp==2
        constantCH4
    elseif Comp==3
        constantCO
    elseif Comp==4
        constantCO2
    elseif Comp==5
        constantH2
    elseif Comp==6
        constantN2
    end

    
    %ELEMENT ROUTINE:
Noe=4; %5 5 7 13 case 3
Ne(1)=3; %14
Ne(2)=3;  %8
Ne(3)=3;
Ne(4)=20;
% Ne(5)=6;
% Ne(6)=6;
% Ne(7)=6;
% Ne(8)=6;
% Ne(9)=6;
% Ne(10)=6;
% Ne(11)=3;
% Ne(12)=3;
% Ne(13)=3;
% Ne(14)=3;
% Ne(15)=3;


Length(1)=0.78;
Length(2)=0.06;
Length(3)=0.04;
Length(4)=0.12;
% Length(5)=0.02;
% Length(6)=0.015;
% Length(7)=0.015;
% Length(8)=0.015;
% Length(9)=0.015;
% Length(10)=0.01;
% Length(11)=0.01;
% Length(12)=0.01;
% Length(13)=0.01;
% Length(14)=0.01;
% Length(15)=0.01;
sum(Length)

StartE=zeros(Noe,1);
for i=2:Noe
    StartE(i)=StartE(i-1)+Length(i-1);
end


for i=1:Noe
[rE{i} DE{i} BDE{i} qE{i}] = colloc(Ne(i)-2,1,1);
%mapping
rE{i}=rE{i}*Length(i)+StartE(i);
DE{i}=DE{i}/Length(i);
qE{i}=qE{i}*Length(i);
end
%total number of points:
Npoints=sum(Ne)-max(size(Ne))+1;
N=Npoints

%cumulative addition of elements:
Nec=ones(Noe+1,1);
Nec(2)=Ne(1);
for i=2:Noe
    Nec(i+1)=Nec(i)+Ne(i)-1;
end
Necspace=Nec-1;
% r vector for solution:
r=zeros(N,1);
for E=1:Noe
r(Nec(E):Nec(E+1))=rE{E};
end
r=r*Rp;


%Initial Mass fractions:
Wic=Yic.*MMASS./(Yic*MMASS');

f=[zeros(N,1);ones(N,1);...
    
   zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);...
   
   ones(N,1)*Wic(1);ones(N,1)*Wic(2);ones(N,1)*Wic(3);...
   ones(N,1)*Wic(4);ones(N,1)*Wic(5);ones(N,1)*Wic(6);...
   
   ones(N,1);ones(N,1)];

%preload variables freom IC vector:
W=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Flux=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
v=[f(14*N+1:15*N)];
Pl=[f(15*N+1:16*N)];
T=f(N+1:2*N)*Tref;

ant=16;%antall ligninger

%define weights for error calculation:
w=[];
for i=1:ant
    we=zeros(N,1);
    for E=1:Noe
    we(Nec(E):Nec(E+1))=we(Nec(E):Nec(E+1))+qE{E};
    end
    w=[w;we];
end

fold=f;
Pulse=1;
vcrelaxed=zeros(N,1);
while residual>tol %&& itcount <250

    v=v*CONVswitch;
    [VISg, vis_comp] = viscosity(T,W,N); %massfraction 
    
    
   %convert to molfrac for reaction
     for k=1:N
     Y(k,:)=W(k,:)./MMASS./sum((W(k,:)./MMASS));
     end

    %change position for the automatic reaction H20 N2
   
    if Comp==2%CH4
    Yc=[Y(:,6),Y(:,2),Y(:,3),Y(:,4),Y(:,1),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,5),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,1)];
    
    elseif Comp==3%CO
    Yc=[Y(:,1),Y(:,6),Y(:,3),Y(:,4),Y(:,2),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,5),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,2)];
    
    elseif Comp==4%CO2
    Yc=[Y(:,1),Y(:,2),Y(:,6),Y(:,4),Y(:,3),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,5),Rcomp(:,4),Rcomp(:,6),Rcomp(:,3)];
    
    elseif Comp==5%H2
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,6),Y(:,4),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,5),Rcomp(:,6),Rcomp(:,4)];
    
    elseif Comp==1 %H2O
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)]; 
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,5)];
    
    elseif Comp==6 %N2
    %change position for the automatic reaction H20 N2
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,5),Rcomp(:,6)];
    end   

    
    for k=1:N
    Rcomp(k,:)=Rcomp(k,:).*MMASS;
    end
     
%molar mass average
Mav=1./(W*(1./MMASS'));

%calculate Density of gas:
RHOgas=Pl*Pic.*Mav./GASCONST./T;
RHOgasref=Pic.*1./(Wic*(1./MMASS'))/GASCONST./Tref;
RHOgasl=RHOgas/RHOgasref;

%derivative of average molecularweight and density
% for E=1:Noe
% DMav(Nec(E):Nec(E+1))=DE{E}*Mav(Nec(E):Nec(E+1));
% end
Difftermsource=zeros(N,6);
if diffmodel==1
    %Calculation of the Sum parts in the WILKE equations:
    sumWrMwrDsr=zeros(N,6);
    sumJMwrDsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                sumWrMwrDsr(k,i)=sumWrMwrDsr(k,i)+W(k,j)/Diff(i,j)/MMASS(j)*Mav(k)/(1-W(k,i));
                 end
             end
         end
    end

    %defining Da and the derivative of DA
Ds=1./sumWrMwrDsr;
Dref=Ds(N,3);
  for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./RHOgasl;
 end
 Difftermsource=zeros(N,6);
 
elseif diffmodel==2
    %Calculation of the Sum parts in the WILKE-BOS equations:
    sumWrMwrDsr=zeros(N,6);
    sumJMwrDsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                sumWrMwrDsr(k,i)=sumWrMwrDsr(k,i)+W(k,j)/Diff(i,j)/MMASS(j)*Mav(k)/(1-W(k,i));
                 end
             end
         end
    end
for i=1:6
    Dk(:,i)=48.5*dpore*(T/MMASS(i)).^0.5*eps/tau;
end 
    
    %defining Da and the derivative of DA
Dim=1./sumWrMwrDsr;
Dsinv=1./Dim+1./Dk;
Ds=1./Dsinv;
Dref=Ds(N,3);
  for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./RHOgasl;
 end
 Difftermsource=zeros(N,6);
elseif diffmodel==3
    %Calculation of the Sum parts in the MS equations:
    sumWrMwrDsr=zeros(N,6);
    sumJMwrDsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumWrMwrDsr(k,i)=sumWrMwrDsr(k,i)+W(k,j)/Diff(i,j)/MMASS(j)*Mav(k);
                 end
             end
         end
    end

    %defining Da and the derivative of DA
Ds=1./sumWrMwrDsr;
Dref=Ds(N,3);
%Calculation of the Sum parts in the MS equations:
 for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     
                     sumJMwrDsr(k,i)=sumJMwrDsr(k,i)+Flux(k,j)*Dref/Diff(i,j)/MMASS(j)*Mav(k)*W(k,i);
                  end
             end
         end
 end
 for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./RHOgasl;
 end

 for i=1:6
     for E=1:Noe
     Difftermsource(Nec(E):Nec(E+1),i)=Difftermsource(Nec(E):Nec(E+1),i)-1./Mav(Nec(E):Nec(E+1)).*(DE{E}*Mav(Nec(E):Nec(E+1))).*W(Nec(E):Nec(E+1),i)+RHOgasref./RHOgas(Nec(E):Nec(E+1)).*sumJMwrDsr(Nec(E):Nec(E+1),i);
     end
  end
 
 
 
elseif diffmodel==4
    %knudsen diffusion:
%http://www.springerlink.com/content/3r71012k1u2t2766/
for i=1:6
    Dk(:,i)=48.5*dpore*(T/MMASS(i)).^0.5*eps/tau;
end
%Calculation of the Sum parts in the DUSTYGAS equations:
    sumWrMwrDsr=zeros(N,6);
    sumJMwrDsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumWrMwrDsr(k,i)=sumWrMwrDsr(k,i)+W(k,j)/Diff(i,j)/MMASS(j)*Mav(k);
                 end
             end
             sumWrMwrDsr(k,i)=sumWrMwrDsr(k,i)+1/Dk(k,i);
         end
    end

    %defining Da and the derivative of DA
Ds=1./sumWrMwrDsr;
Dref=Ds(N,3);
%Calculation of the Sum parts in the DUSTYGAS equations:
 for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     
                     sumJMwrDsr(k,i)=sumJMwrDsr(k,i)+Flux(k,j)*Dref/Diff(i,j)/MMASS(j)*Mav(k)*W(k,i);
                  end
             end
         end
 end
  for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./RHOgasl;
 end
  for i=1:6
     for E=1:Noe
     Difftermsource(Nec(E):Nec(E+1),i)=Difftermsource(Nec(E):Nec(E+1),i)+sumJMwrDsr(Nec(E):Nec(E+1),i)./RHOgasl(Nec(E):Nec(E+1))-W(Nec(E):Nec(E+1),i)./Mav(Nec(E):Nec(E+1)).*(DE{E}*Mav(Nec(E):Nec(E+1)))-v(Nec(E):Nec(E+1)).*Dref.*W(Nec(E):Nec(E+1),i)./RHOgasl(Nec(E):Nec(E+1))./Dk(Nec(E):Nec(E+1),i);                                                                
     end
  end
end


    CPg = Heat_capacity(Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6),T);

vc=zeros(N,1);
  for i=1:6
     for E=1:Noe
     vc(Nec(E):Nec(E+1),1)=vc(Nec(E):Nec(E+1),1)+Ds(Nec(E):Nec(E+1),i).*(DE{E}*W(Nec(E):Nec(E+1),i))/Rp;                                                               
     end
  end
  
  vcDl=vc/Dref*Rp;

  
  
  
for E=1:Noe
    for i=1:6
Diffmodel{E,i}=diag(Difftermcolloc{i}(Nec(E):Nec(E+1)));
    end
    for k=Nec(E):Nec(E+1)
    DwvrhoE{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)*v(k)*RHOgasl(k);
    DtempE{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)*Dref/lambda*(v(k)-vcDl(k))*RHOgasl(k)*RHOgasref*CPg(k);
    end
    DarcyE{E}=diag(Dref.*VISg(Nec(E):Nec(E+1))/B0/Pic);
end


    %automatic for elements:
    R=zeros(N,ant*N,ant);
    for E=1:Noe
        %initspace=zeros(Ne(i),Necspace(i));
        SEEND=zeros(Ne(E),Nec(end)-Nec(E+1));
        SESTART=zeros(Ne(E),Necspace(E));
R(Nec(E):Nec(E+1),:,1)=R(Nec(E):Nec(E+1),:,1)  +[SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-2))];
R(Nec(E):Nec(E+1),:,2)=R(Nec(E):Nec(E+1),:,2)  +[SESTART,diag(2./rE{E})+DE{E},SEEND,SESTART,DtempE{E},SEEND,zeros(Ne(E),N*(ant-2))];
R(Nec(E):Nec(E+1),:,3)=R(Nec(E):Nec(E+1),:,3)  +[zeros(Ne(E),N*2),SESTART,Diffmodel{E,1},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-9))];
R(Nec(E):Nec(E+1),:,4)=R(Nec(E):Nec(E+1),:,4)  +[zeros(Ne(E),N*3),SESTART,Diffmodel{E,2},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-10))];
R(Nec(E):Nec(E+1),:,5)=R(Nec(E):Nec(E+1),:,5)  +[zeros(Ne(E),N*4),SESTART,Diffmodel{E,3},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-11))];
R(Nec(E):Nec(E+1),:,6)=R(Nec(E):Nec(E+1),:,6)  +[zeros(Ne(E),N*5),SESTART,Diffmodel{E,4},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-12))];
R(Nec(E):Nec(E+1),:,7)=R(Nec(E):Nec(E+1),:,7)  +[zeros(Ne(E),N*6),SESTART,Diffmodel{E,5},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-13))];
R(Nec(E):Nec(E+1),:,8)=R(Nec(E):Nec(E+1),:,8)  +[zeros(Ne(E),N*7),SESTART,Diffmodel{E,6},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-14))];
R(Nec(E):Nec(E+1),:,9)=R(Nec(E):Nec(E+1),:,9)  +[zeros(Ne(E),N*2),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DwvrhoE{E},SEEND,zeros(Ne(E),N*(ant-9))];
R(Nec(E):Nec(E+1),:,10)=R(Nec(E):Nec(E+1),:,10)+[zeros(Ne(E),N*3),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DwvrhoE{E},SEEND,zeros(Ne(E),N*(ant-10))];
R(Nec(E):Nec(E+1),:,11)=R(Nec(E):Nec(E+1),:,11)+[zeros(Ne(E),N*4),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DwvrhoE{E},SEEND,zeros(Ne(E),N*(ant-11))];
R(Nec(E):Nec(E+1),:,12)=R(Nec(E):Nec(E+1),:,12)+[zeros(Ne(E),N*5),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DwvrhoE{E},SEEND,zeros(Ne(E),N*(ant-12))];
R(Nec(E):Nec(E+1),:,13)=R(Nec(E):Nec(E+1),:,13)+[zeros(Ne(E),N*6),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DwvrhoE{E},SEEND,zeros(Ne(E),N*(ant-13))];
R(Nec(E):Nec(E+1),:,14)=R(Nec(E):Nec(E+1),:,14)+[zeros(Ne(E),N*7),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DwvrhoE{E},SEEND,zeros(Ne(E),N*(ant-14))];
R(Nec(E):Nec(E+1),:,15)=R(Nec(E):Nec(E+1),:,15)+[zeros(Ne(E),N*14),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*(ant-15))];
R(Nec(E):Nec(E+1),:,16)=R(Nec(E):Nec(E+1),:,16)+[zeros(Ne(E),N*14),SESTART,DarcyE{E},SEEND,SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-16))];
    end  
    
     A=[R(:,:,1);R(:,:,2);R(:,:,3);R(:,:,4);R(:,:,5);R(:,:,6);R(:,:,7);R(:,:,8);...
         R(:,:,9);R(:,:,10);R(:,:,11);R(:,:,12);R(:,:,13);R(:,:,14);R(:,:,15);R(:,:,16)]; 
    
    
%Boundary conditions in A matrix:
%Q   
A(N,1:2*N)=zeros(1,2*N);
if Tlswitch==0
    A(N,2*N)=1;
elseif Tlswitch==1
    A(N,2*N)=h; %T^*
end

%T
A(N+1,1:2*N)=zeros(1,2*N);
A(N+1,1)=1;

%MS CH4 CO CO2 H2 N2 
 for i=1:6
 A((2+i)*N,1:ant*N)=zeros(1,ant*N);
 A((2+i)*N,(8+i)*N)=1;
 end

% molefrac CH4 CO CO2 H2 N2
 for i=1:6
      A((7+i)*N+1,1:(ant*N))=zeros(1,ant*N);
      A((7+i)*N+1,(1+i)*N+1)=1;
 end

 %Cont
A(14*N+1,1:ant*N)=zeros(1,ant*N);
A(14*N+1,14*N+1)=1;

A(16*N,1:ant*N)=zeros(1,ant*N);
A(16*N,16*N)=1;
 
%Boundary conditions in source vector
F=zeros(N*ant,1);

%------------------------------------------------------

%Qeq
if Tlswitch==0
    F(N)=1;
elseif Tlswitch==1
    F(N)=f(N)*lambda/Rp+RHOgas(N)*CPg(N)*T(N)/Tref*v(N)*Dref/Rp+h;
end

%Teq:
for E=1:Noe
F(N+Nec(E):N+Nec(E+1))=F(N+Nec(E):N+Nec(E+1))-DELTAHr(Nec(E):Nec(E+1)).*Rp^2./Tref./lambda;
end

F(N+1)=0;


% Diffusion model source terms:
%
% Overlapping made in the diffusion models..........!!!!!!!
 for i=1:6
        F((1+i)*N+1:(2+i)*N)=Difftermsource(:,i);
 end
 

 % BC at surface diffusive equations:
 if Tlswitch==0
    for i=1:6
    F((2+i)*N)=Wic(i);
    end
elseif Tlswitch==1
    for i=1:6
    F((2+i)*N)=((Flux(N,i)*Dref/Rp+v(N)*Dref/Rp*RHOgasl(N)*W(N,i))/ki(i)+Wic(i))/RHOgasl(N);
    end
 end

 
%J eq CH4 CO CO2 H2
 for i=1:6
     for E=1:Noe
        F((7+i)*N+Nec(E):(7+i)*N+Nec(E+1))=F((7+i)*N+Nec(E):(7+i)*N+Nec(E+1))+Rcomp(Nec(E):Nec(E+1),i)*rhop*(1-eps)*Rp^2/RHOgasref/Dref;
     end
 end


%BC at senter
for i=1:6
F((7+i)*N+1)=0;
end

%sum fluxes:
% F(7*N+1:8*N)=zeros(N,1);
%sum molfracs:
% for E=1:Noe
% F((13)*N+Nec(E):(13)*N+Nec(E+1))=F((13)*N+Nec(E):(13)*N+Nec(E+1))+ones(Ne(E),1);
% end


%continuity
for E=1:Noe
F((14)*N+Nec(E):(14)*N+Nec(E+1))=F((14)*N+Nec(E):(14)*N+Nec(E+1))-DE{E}*RHOgasl(Nec(E):Nec(E+1)).*v(Nec(E):Nec(E+1))./RHOgasl(Nec(E):Nec(E+1));
end
F(14*N+1)=0;

%darcy's law
F(15*N+1:16*N)=F(15*N+1:16*N)-vcDl.*VISg*Dref/B0/Pic;
F(16*N)=1; 

fold=f;

%solve
f=A\F;

itcount=itcount+1;

% Pulse relaxation:
Pulse=Pulse+1;
if Pulse>100 && itcount>5000
alpha=0.02;
alphaj=1;
f(1:N)=alpha*f(1:N)+(1-alpha)*fold(1:N);
f(N+1:2*N)=(alphaj*f(N+1:2*N)+(1-alphaj)*fold(N+1:2*N));
f(2*N+1:8*N)=alphaj*f(2*N+1:8*N)+(1-alphaj)*fold(2*N+1:8*N);
f(8*N+1:14*N)=max(alpha*f(8*N+1:14*N)+(1-alpha)*fold(8*N+1:14*N),0.000000000001);
Pulse=1;
else

% relaxation of the iteration:
alpha=0.0001;
alphaj=1;

f(1:N)=alpha*f(1:N)+(1-alpha)*fold(1:N);
f(N+1:2*N)=(alphaj*f(N+1:2*N)+(1-alphaj)*fold(N+1:2*N));
f(2*N+1:8*N)=alphaj*f(2*N+1:8*N)+(1-alphaj)*fold(2*N+1:8*N);
f(8*N+1:14*N)=max(alpha*f(8*N+1:14*N)+(1-alpha)*fold(8*N+1:14*N),0.000000000001);
end
%update Molfracs and temperature and gather fluxes
W=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Flux=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
v=[f(14*N+1:15*N)];
Pl=[f(15*N+1:16*N)];
T=f(N+1:2*N)*Tref;

%residual
residual=sqrt((A*f-F)'*diag(w)*(A*f-F))
end

%convert to molfrac for plotting
     for i=1:N
     Y(i,:)=W(i,:)./MMASS./sum((W(i,:)./MMASS));
     end

     u=zeros(N,1);
for i=1:6
        u=u+Flux(:,i).*Mav/MMASS(i)./RHOgasl;
end
u=u+v;

    if Comp==1 %H2O
    elseif Comp==2%CH4
        Y=[Y(:,6),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,1)];
    elseif Comp==3%CO
        Y=[Y(:,1),Y(:,6),Y(:,3),Y(:,4),Y(:,5),Y(:,2)];
    elseif Comp==4%CO2
        Y=[Y(:,1),Y(:,2),Y(:,6),Y(:,4),Y(:,5),Y(:,3)];
    elseif Comp==5%H2
        Y=[Y(:,1),Y(:,2),Y(:,3),Y(:,6),Y(:,5),Y(:,4)];
    elseif Comp==6 %N2
        Y=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)];
    end

%save workspace:
    if Comp==1 %H2O
        if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE H2O NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS H2O NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS H2O NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty H2O NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE H2O NOTL')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS H2O NOTL')
                elseif diffmodel==3
                    save('MASS ELEM MS H2O NOTL')
                elseif diffmodel==4
                    save('MASS ELEM Dusty H2O NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE H2O NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS H2O NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS H2O NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty H2O NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE H2O')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS H2O')
                elseif diffmodel==3
                    save('MASS ELEM MS H2O')
                elseif diffmodel==4
                    save('MASS ELEM Dusty H2O')
                end
                        end
        end
                    
    elseif Comp==2%CH4
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE CH4 NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CH4 NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS CH4 NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CH4 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE CH4 NOTL')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CH4 NOTL')
                elseif diffmodel==3
                    save('MASS ELEM MS CH4 NOTL')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CH4 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE CH4 NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CH4 NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS CH4 NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CH4 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE CH4')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CH4')
                elseif diffmodel==3
                    save('MASS ELEM MS CH4')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CH4')
                end
                        end
        end
       
    elseif Comp==3%CO
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE CO NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CO NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS CO NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CO NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE CO NOTL')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CO NOTL')
                elseif diffmodel==3
                    save('MASS ELEM MS CO NOTL')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CO NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE CO NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CO NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS CO NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CO NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE CO')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CO')
                elseif diffmodel==3
                    save('MASS ELEM MS CO')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CO')
                end
                        end
        end
    elseif Comp==4%CO2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE CO2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CO2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS CO2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CO2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE CO2 NOTL')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CO2 NOTL')
                elseif diffmodel==3
                    save('MASS ELEM MS CO2 NOTL')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CO2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE CO2 NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CO2 NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS CO2 NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CO2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE CO2')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS CO2')
                elseif diffmodel==3
                    save('MASS ELEM MS CO2')
                elseif diffmodel==4
                    save('MASS ELEM Dusty CO2')
                end
                        end
        end
    elseif Comp==5%H2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE H2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS H2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS H2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty H2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE H2 NOTL')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS H2 NOTL')
                elseif diffmodel==3
                    save('MASS ELEM MS H2 NOTL')
                elseif diffmodel==4
                    save('MASS ELEM Dusty H2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE H2 NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS H2 NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS H2 NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty H2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE H2')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS H2')
                elseif diffmodel==3
                    save('MASS ELEM MS H2')
                elseif diffmodel==4
                    save('MASS ELEM Dusty H2')
                end
                        end
        end
    elseif Comp==6 %N2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE N2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS N2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS N2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty N2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE N2 NOTL')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS N2 NOTL')
                elseif diffmodel==3
                    save('MASS ELEM MS N2 NOTL')
                elseif diffmodel==4
                    save('MASS ELEM Dusty N2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS ELEM WILKE N2 NOCONV')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS N2 NOCONV')
                elseif diffmodel==3
                    save('MASS ELEM MS N2 NOCONV')
                elseif diffmodel==4
                    save('MASS ELEM Dusty N2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS ELEM WILKE N2')
                elseif diffmodel==2
                    save('MASS ELEM WILKE-BOS N2')
                elseif diffmodel==3
                    save('MASS ELEM MS N2')
                elseif diffmodel==4
                    save('MASS ELEM Dusty N2')
                end
                        end
        end
 end
    %reset residual & itcount & solution vector;
residual=1;

%writeout residual & error
%Amount of time used on calucation
timespent=toc
sqrt((f-fold)'*diag(w)*(f-fold))
residual=sqrt((A*f-F)'*diag(w)*(A*f-F))
itcount
%end
end
end
end
end
