clear all
close all
clc
tic

constant

%For loops:
% i = main component
% j = secondary component
% k = position in particle
 
%Colloc.m routine
[r D BD q] = colloc(N-2,1,1);

f=[zeros(N,1);ones(N,1);... %temperature and
    %Fluxes
  zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);...
    %Species balance
  ones(N,1)*Yic(1);ones(N,1)*Yic(2);ones(N,1)*Yic(3);...
  ones(N,1)*Yic(4);ones(N,1)*Yic(5);ones(N,1)*Yic(6);...
    %Ideal gas law, Continuity, Darcys law
  ones(N,1);ones(N,1)*10^-6;ones(N,1)];

fold=f;

%inital molefractions
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];

ant=17;%equations in the main matrix

%define weights for error calculation:
w=[];
for i=1:ant
    w=[w;q];
end

while residual>tol %&& itcount <500
   
    %calculate reaction rate and heat, Constant pressure
    Yreaction=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)]; %change the order for the reaction file
    
    [Rcomp,DELTAHr] = reaction(T,Yreaction,Pic.*Pl);
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,5)]; %change the two last components

    %calculate cocentration:

Mav=Y*MMASS';
Mavl=Mav/Mavref;
C=RHOl*RHOref./Mav;
Cl=C/Cref;

    %Calculate derivative of consentration
    %DCl=D*Cl;
    
  
%Calculation of the Sum parts in the MS equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j);
                 end
             end
         end
    end
    
    %Define Ds and Dref
    Ds=1./sumwrmwrdsr;
    Dref=Ds(N,3);
       
 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
    
% convective terms  
% conv velocity

for i=1:N
W(i,:)=Y(i,:).*MMASS./((Y(i,:)*MMASS'));
end 
[VISg, vis_comp] = viscosity(T,W,N); %massfraction


%Calculate molar velocity converted from fluxes:
velconv=zeros(N,1);
 for i=1:6
     velconv=velconv+Flux(:,i)*MMASS(i)./Mav./Cl;
 end
 uconv=-velconv+v;
 %-------
 
 %Calculate average CP for gas:
 CPg = Heat_capacitymol(Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6),T);
 %---------
 
 %Convective/derivative terms:
 for k=1:N
     %Convective term Temperature equation:
     Dtemp(k,:)=D(k,:)*Dref/lambda*v(k)*Cl(k)*Cref*CPg(k);
     
     %dimensionless RHO from ideal gas law
     DPMavRT2(k,:)=D(k,:)*Pl(k)*Pic*Mav(k)/RHOref/T(k)^2/GASCONST*Tref;
     DMRT(k,:)=D(k,:)*Mav(k)/GASCONST/T(k)*Pic/RHOref;
     
     %Mass continuity:
     DRHOv(k,:)=D(k,:)*v(k)/RHOl(k);
     %Molar continuity:
     DRHOu(k,:)=D(k,:)*uconv(k)/Mavl(k)/Cl(k);

     %Convective term species mole balance
     DCvelconv(k,:)=D(k,:)*Cl(k)*uconv(k);    
 end

%relaxation needed for the convective term
alphatest=0.001;
DCvelconvRelaxed=DCvelconv*alphatest+(1-alphatest)*DCvelconvRelaxed;
    
    % Main matrix
     A=[...
        diag(ones(N,1))   ,    D        , zeros(N,N*(ant-2));...                           % Q equation 1 fouriers law
        diag(2./r)+D      , Dtemp  , zeros(N,N*(ant-2));...                           % T equation 2
        zeros(N,2*N) , diag(Dref.*Cref./Ds(:,1)./C)  ,  zeros(N,5*N) , D ,     zeros(N,N*(ant-9));...      %MS CH4 
        zeros(N,3*N) , diag(Dref.*Cref./Ds(:,2)./C)  ,  zeros(N,5*N) , D ,     zeros(N,N*(ant-10));...     %MS CO
        zeros(N,4*N) , diag(Dref.*Cref./Ds(:,3)./C)  ,  zeros(N,5*N) , D ,     zeros(N,N*(ant-11));...     %MS CO2    X
        zeros(N,5*N) , diag(Dref.*Cref./Ds(:,4)./C)  ,  zeros(N,5*N) , D ,     zeros(N,N*(ant-12));...     %MS H2
        zeros(N,6*N) , diag(Dref.*Cref./Ds(:,5)./C)  ,  zeros(N,5*N) , D ,     zeros(N,N*(ant-13));...     %MS N2
        zeros(N,2*N) , diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), zeros(N,N*(ant-8));...
        zeros(N,2*N) ,  D+diag(2./r)   ,  zeros(N,5*N),DCvelconvRelaxed , zeros(N,N*(ant-9));... %Molfrac CH4 10       J
        zeros(N,3*N) ,  D+diag(2./r)   ,  zeros(N,5*N),DCvelconvRelaxed , zeros(N,N*(ant-10));...%Molfrac CO
        zeros(N,4*N) ,  D+diag(2./r)   ,  zeros(N,5*N),DCvelconvRelaxed , zeros(N,N*(ant-11));...%Molfrac CO2
        zeros(N,5*N) ,  D+diag(2./r)   ,  zeros(N,5*N),DCvelconvRelaxed , zeros(N,N*(ant-12));...%Molfrac H2
        zeros(N,6*N) ,  D+diag(2./r)   ,  zeros(N,5*N),DCvelconvRelaxed , zeros(N,N*(ant-13));...%Molfrac N2
        zeros(N,8*N) , diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)),zeros(N,N*(ant-14));...
        zeros(N,N)   , DPMavRT2 ,zeros(N,12*N), D ,zeros(N,N), -DMRT,zeros(N,N*(ant-17));...
        zeros(N,14*N), DRHOv ,D+diag(2./r),zeros(N,N*(ant-16)) ;...
        zeros(N,15*N), diag(Dref.*VISg/B0/Pic),D,zeros(N,N*(ant-17))];...
%Boundary conditions in A matrix:
%Q   
A(N,1:2*N)=zeros(1,2*N);
A(N,2*N)=1;

%T
A(N+1,1:2*N)=zeros(1,2*N);
A(N+1,1)=1;

%MS CH4 CO CO2 H2 N2 
 for i=1:5
     A((2+i)*N,1:ant*N)=zeros(1,ant*N);
     A((2+i)*N,(8+i)*N)=1;
 end

% molefrac CH4 CO CO2 H2 N2
 for i=1:5
      A((7+i)*N+1,1:(ant*N))=zeros(1,ant*N);
      A((7+i)*N+1,(1+i)*N+1)=1;
 end
 
   %Ideal gas law
 A(15*N,1:ant*N)=zeros(1,ant*N);
 A(15*N,15*N)=1;

  %Continuity
A(15*N+1,1:ant*N)=zeros(1,ant*N);
A(15*N+1,15*N+1)=1;
  
  %darcy
A(17*N,1:ant*N)=zeros(1,ant*N);
A(17*N,17*N)=1;

%Boundary conditions in source vector
F=zeros(N*ant,1);

%Qeq
F(N)=1;

%Teq:
F(N+1:2*N)=-DELTAHr.*Rp^2./Tref./lambda;
F(N+1)=0;

% Maxwellstefan
 for i=1:5
     for k=1:N
     F((1+i)*N+k)=sumjrmwrdsr(k,i)*Cref/C(k);
     end
 end

for i=1:5
    F((2+i)*N)=Yic(i);
end



%J eq CH4 CO CO2 H2 N2 H2O
for i=1:5
    for k=1:N
        F((7+i)*N+k)=(Rcomp(k,i)-sum(Rcomp(k,:)')*Y(k,i))*rhop*(1-eps)*Rp^2/Cref/Dref;
    end
end

%BC at senter
for i=1:5
F((7+i)*N+1)=0;
end

F(7*N+1:8*N)=zeros(N,1);
F(13*N+1:14*N)=ones(N,1);

%ideal gas law
Dideal=D*Mav;
F(14*N+1:15*N)=Dideal.*Pl*Pic/GASCONST./T/RHOref;
F(15*N)=1;


F(15*N+1)=0;

F(17*N)=1;

fold=f;

%solve
f=A\F;

itcount=itcount+1;
% relaxation of the iteration:
alpha=0.0014;
alphaj=1;
alphaCl=0.1;
alphaC=0.1;
alphaP=0.1;
f(1:N)=alpha*f(1:N)+(1-alpha)*fold(1:N);
f(N+1:2*N)=max(alpha*f(N+1:2*N)+(1-alpha)*fold(N+1:2*N),0.5);
f(2*N+1:8*N)=alphaj*f(2*N+1:8*N)+(1-alphaj)*fold(2*N+1:8*N);
f(8*N+1:14*N)=max(alpha*f(8*N+1:14*N)+(1-alpha)*fold(8*N+1:14*N),0.00001);
f(14*N+1:15*N)=max(alphaCl*f(14*N+1:15*N)+(1-alphaCl)*fold(14*N+1:15*N),0.9);
f(15*N+1:16*N)=alphaC*f(15*N+1:16*N)+(1-alphaC)*fold(15*N+1:16*N);
f(16*N+1:17*N)=max(alphaP*f(16*N+1:17*N)+(1-alphaP)*fold(16*N+1:17*N),0.5);

%update Molfracs and temperature
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Flux=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
T=f(N+1:2*N)*Tref;
RHOl=f(14*N+1:15*N);
v=f(15*N+1:16*N);
Pl=f(16*N+1:17*N);

residual=sqrt((A*f-F)'*diag(w)*(A*f-F))
end

%plot results
%figure
r=r*Rp;
subplot(3,3,1)
hold on
plot(r,f(N+1:2*N)*Tref,'r')
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];

MMASS(1) = 16.04;         % Molemass CH4
MMASS(2) = 28.01;         % Molemass CO
MMASS(3) = 44.01;         % Molemass CO2
MMASS(4) =  2.02;         % Molemass H2
MMASS(5) = 28.01;         % Molemass N2
MMASS(6) = 18.02;         % Molemass H2O

for i=1:N
    W(i,:)=Y(i,:).*MMASS./((Y(i,:)*MMASS'));
end
for i=1:6
    subplot(3,3,i+1)
    hold on
plot(r,Y(:,i),'r')
end
%legends
subplot(3,3,1)
title('Temperature')
subplot(3,3,2)
title('CH4')
subplot(3,3,3)
title('CO')
subplot(3,3,4)
title('CO2')
subplot(3,3,5)
title('H2')
subplot(3,3,6)
title('N2')
subplot(3,3,7)
title('H2O')

% figure %fluxes
% for i =1:6
%     subplot(3,3,i+1)
%     hold on
% plot(r,f((1+i)*N+1:(2+i)*N))
% end
% %legends
% subplot(3,3,1)
% title('Temperature')
% subplot(3,3,2)
% title('CH4')
% subplot(3,3,3)
% title('CO')
% subplot(3,3,4)
% title('CO2')
% subplot(3,3,5)
% title('H2')
% subplot(3,3,6)
% title('N2')
% subplot(3,3,7)
% title('H2O')


%writeout residual & error
%Amount of time used on calucation
toc
sqrt((f-fold)'*diag(w)*(f-fold))
residual=sqrt((A*f-F)'*diag(w)*(A*f-F))
itcount
