function Ld = LegendreDerivative(n,x)
% LegendreDerivative(n,x)
% This function returns the value of the 1st derivative of the 
% Legendre polynomial of degre n evaluated in the point x.
% n= polynomial order
% x= coordinate 
% Dorao, C.A. 
% Modifications, Thomas Montazaud 2010

Ln = zeros(n+1,1);

Ln(1) = 1; %Ld(1) = 0;
Ln(2) = x; %Ld(2) = 1;

% Have to treat the endpoints separatly
if abs(x)==1
    Ld = x^(n-1)*(1/2)*n*(n+1);
    
% For not-endpoints
else
    for i = 1:n-1
        Ln(i+2) = (2*i+1)/(i+1)*x*Ln(i+1) - i/(i+1)*Ln(i);
    end
    Ld = n/(1-x^2)*Ln(n) - n*x/(1-x^2)*Ln(n+1);
end