%diffusion coeffisients:

function [Diff]=diffcoef(T,P)

global MMASS sigma ek tau eps
        % Coefficient for CH4      [-]
         % Coefficient for CO       [-]
        % Coefficient for CO2      [-]
        % Coefficient for H2       [-]
         % Coefficient for N2       [-]
        % Coefficient for H2O      [-]
        
P=P*10^-5; %Pa to bar

A=1.06036;
B=0.15610;
C=0.19300;
D=0.47635;
E=1.03587;
F=1.52996;
G=1.76474;
H=3.89411;

Diff=zeros(6,6);
for i=1:6
     for j=1:6
         if i==j
         else
             sigmas=(sigma(i)+sigma(j))/2;
             eks=(ek(i)*ek(j))^0.5;
             intd=A/(T/eks)^B+C/exp(D*T/eks)+E/exp(F*T/eks)+G/exp(H*T/eks);
             Mij=2*((1/MMASS(i))+(1/MMASS(j)))^-1;
             Diff(i,j)=0.00266*T^(3/2)/P/Mij^0.5/sigmas^2/intd;

         end
     end
 end
Diff=Diff/10000*eps/tau; %cm2/s to m2/s



end