clear all
clc
for i=1:1
Comp=i;
for j=1:1
CONVswitch=j;
for k=1:1
Tlswitch=k;
for l=3:3
diffmodel=l;
tic
global N  GASCONST MMASS

%For loops:
% i = main component
% j = secondary component
% k = position in particle

%convective on off
% ConvSWITCH=1;% on=1 off=0

%BC - transfer limitations on off
% TlSWITCH=1;

%Diffusion model
% DIFFmodel=1;
%1=Wilke
%2=Wilke Bosanquet
%3=MS
%4=Dusty gas

%component solved by 1-sum(N-1)
% CompSOLV=1;
%1=CH4
%2=CO2
%3=CO
%4=H2
%5=N2
%6=H2O


    %ELEMENT ROUTINE:
Noe=4; %5 5 7 13 case 3
Ne(1)=3; %14
Ne(2)=3;  %8
Ne(3)=4;
Ne(4)=24;
% Ne(5)=6;
% Ne(6)=6;
% Ne(7)=6;
% Ne(8)=6;
% Ne(9)=20;


Length(1)=0.78;
Length(2)=0.06;
Length(3)=0.04;
Length(4)=0.12;
% Length(5)=0.04;
% Length(6)=0.03;
% Length(7)=0.02;
% Length(8)=0.01;
% Length(9)=0.09;
sum(Length)

StartE=zeros(Noe,1);
for i=2:Noe
    StartE(i)=StartE(i-1)+Length(i-1);
end


for i=1:Noe
[rE{i} DE{i} BDE{i} qE{i}] = colloc(Ne(i)-2,1,1);
%mapping
rE{i}=rE{i}*Length(i)+StartE(i);
DE{i}=DE{i}/Length(i);
qE{i}=qE{i}*Length(i);
end
%total number of points:
Npoints=sum(Ne)-max(size(Ne))+1;
N=Npoints

%cumulative addition of elements:
Nec=ones(Noe+1,1);
Nec(2)=Ne(1);
for i=2:Noe
    Nec(i+1)=Nec(i)+Ne(i)-1;
end
Necspace=Nec-1;

%load constants:
    if Comp==1
        constantH2O
    elseif Comp==2
        constantCH4
    elseif Comp==3
        constantCO
    elseif Comp==4
        constantCO2
    elseif Comp==5
        constantH2
    elseif Comp==6
        constantN2
    end

    % r vector for solution:
r=zeros(Npoints,1);
for E=1:Noe
r(Nec(E):Nec(E+1))=rE{E};
end
r=r*Rp;

f=[zeros(N,1);ones(N,1);... %temperature and
    %Fluxes
  zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);...
    %Species balance
  ones(N,1)*Yic(1);ones(N,1)*Yic(2);ones(N,1)*Yic(3);...
  ones(N,1)*Yic(4);ones(N,1)*Yic(5);ones(N,1)*Yic(6);...
    %Ideal gas law, Continuity, Darcys law
  ones(N,1);ones(N,1)*10^-6;ones(N,1)];

% load('Ficmole')

%preload variables freom IC vector:
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Flux=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
T=f(N+1:2*N)*Tref;
Cl=f(14*N+1:15*N);
u=f(15*N+1:16*N);
Pl=f(16*N+1:17*N);

fold=f;

%inital molefractions
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];

ant=17;%equations in the main matrix

%define weights for error calculation:
w=[];
for i=1:ant
    we=zeros(N,1);
    for E=1:Noe
    we(Nec(E):Nec(E+1))=we(Nec(E):Nec(E+1))+qE{E};
    end
    w=[w;we];
end

for E=1:Noe
DCvelconvRelaxedE{E}=zeros(Ne(E));
end


Pulse=1;
while residual>tol %&& itcount <500

    u=u*CONVswitch;
       %change position for the automatic reaction H20 N2
   
    if Comp==2%CH4
    Yc=[Y(:,6),Y(:,2),Y(:,3),Y(:,4),Y(:,1),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,5),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,1)];
    
    elseif Comp==3%CO
    Yc=[Y(:,1),Y(:,6),Y(:,3),Y(:,4),Y(:,2),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,5),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,2)];
    
    elseif Comp==4%CO2
    Yc=[Y(:,1),Y(:,2),Y(:,6),Y(:,4),Y(:,3),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,5),Rcomp(:,4),Rcomp(:,6),Rcomp(:,3)];
    
    elseif Comp==5%H2
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,6),Y(:,4),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,5),Rcomp(:,6),Rcomp(:,4)];
    
    elseif Comp==1 %H2O
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)]; 
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,5)];
    
    elseif Comp==6 %N2
    %change position for the automatic reaction H20 N2
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,5),Rcomp(:,6)];
    end  
%calculate cocentration:
Mav=Y*MMASS';
% C=Pl.*Pic./GASCONST./T;

% Cl=C./Cref;
C=Cl*Cref;

if diffmodel==1
    %Calculation of the Sum parts in the WILKE equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j)/(1-Y(k,i));
                 end
             end
         end
    end
    
   %Define Ds and Dref
    Ds=1./sumwrmwrdsr;
    Dref=Ds(N,3);
     
 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
  for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./Cl;
 end
 Difftermsource=zeros(N,6);
 
elseif diffmodel==2
    %Calculation of the Sum parts in the WILKE-BOS equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j)/(1-Y(k,i));
                 end
             end
         end
    end
    
   %Define Ds and Dref
       %knudsen diffusion:
%http://www.springerlink.com/content/3r71012k1u2t2766/
   for i=1:6
    Dk(:,i)=48.5*dpore*(T/MMASS(i)).^0.5*eps/tau;
end 
   
Dim=1./sumwrmwrdsr;
Dsinv=1./Dim+1./Dk;
Ds=1./Dsinv;
Dref=Ds(N,3);
     
 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
  for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./Cl;
 end
 Difftermsource=zeros(N,6);
elseif diffmodel==3
%Calculation of the Sum parts in the MS equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j);
                 end
             end
         end
    end
    
   %Define Ds and Dref
    Ds=1./sumwrmwrdsr;
    Dref=Ds(N,3);

 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
 for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./Cl;
 end
 for i=1:6
     for k=1:N
 Difftermsource(k,i)=sumjrmwrdsr(k,i)*Cref/C(k);
     end
 end
elseif diffmodel==4
%knudsen diffusion:
%http://www.springerlink.com/content/3r71012k1u2t2766/
for i=1:6
    Dk(:,i)=48.5*dpore*(T/MMASS(i)).^0.5*eps/tau;
end

%Calculation of the Sum parts in the MS equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j);
                 end
             end
             sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+1/Dk(k,i);
         end
    end
    
   %Define Ds and Dref
    Ds=1./sumwrmwrdsr;
    Dref=Ds(N,3);

       
 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
  for i=1:6
 Difftermcolloc{i}=Dref./Ds(:,i)./Cl;
 end
 for i=1:6
     for k=1:N
 Difftermsource(k,i)=sumjrmwrdsr(k,i)/Cl(k)-Y(k,i)*u(k)/Dk(k,i)*Dref;
     end
 end
end


% convective terms  
% conv velocity

for i=1:N
W(i,:)=Y(i,:).*MMASS./((Y(i,:)*MMASS'));
end 
[VISg, vis_comp] = viscosity(T,W,N); %massfraction


%Calculate molar velocity converted from fluxes:
velconv=zeros(N,1);
 for i=1:6
     velconv=velconv+Flux(:,i)*MMASS(i)./Mav./Cl;
 end
%relaxation needed for the convective term
vconv=velconv+u;
vconv=vconv*CONVswitch;
alpha=0.01;
vconvrelaxed=vconv*alpha+(1-alpha)*vconvrelaxed;

 
 %Calculate average CP for gas:
 CPg = Heat_capacitymol(Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6),T);
 %---------
 

% Derivative matrices for spectral elemental method: 
 for E=1:Noe
    for i=1:6
    Diffmodel{E,i}=diag(Difftermcolloc{i}(Nec(E):Nec(E+1)));
    end
    for k=Nec(E):Nec(E+1)
    DtempE{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)*Dref/lambda*vconvrelaxed(k)*Cl(k)*Cref*CPg(k);
         %Molar continuity:
    DCluE{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)*u(k)/Cl(k);
         %Convective term species mole balance
    DCvelconvE{E}(k-Necspace(E),:)=DE{E}(k-Necspace(E),:)*Cl(k)*u(k);
    end
end
 

%relaxation needed for the convective term
alphaCT=0.001;
for E=1:Noe
DCvelconvRelaxedE{E}=DCvelconvE{E}*alphaCT+(1-alphaCT)*DCvelconvRelaxedE{E};
end
    % Main matrix
    % automatic for elements:
    R=zeros(Npoints,ant*Npoints,ant);
    for E=1:Noe
        SEEND=zeros(Ne(E),Nec(end)-Nec(E+1));
        SESTART=zeros(Ne(E),Necspace(E));
R(Nec(E):Nec(E+1),:,1)=R(Nec(E):Nec(E+1),:,1)  +[SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-2))];
R(Nec(E):Nec(E+1),:,2)=R(Nec(E):Nec(E+1),:,2)  +[SESTART,diag(2./rE{E})+DE{E},SEEND,SESTART,DtempE{E},SEEND,zeros(Ne(E),N*(ant-2))];
R(Nec(E):Nec(E+1),:,3)=R(Nec(E):Nec(E+1),:,3)  +[zeros(Ne(E),N*2),SESTART,Diffmodel{E,1},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-9))];
R(Nec(E):Nec(E+1),:,4)=R(Nec(E):Nec(E+1),:,4)  +[zeros(Ne(E),N*3),SESTART,Diffmodel{E,2},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-10))];
R(Nec(E):Nec(E+1),:,5)=R(Nec(E):Nec(E+1),:,5)  +[zeros(Ne(E),N*4),SESTART,Diffmodel{E,3},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-11))];
R(Nec(E):Nec(E+1),:,6)=R(Nec(E):Nec(E+1),:,6)  +[zeros(Ne(E),N*5),SESTART,Diffmodel{E,4},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-12))];
R(Nec(E):Nec(E+1),:,7)=R(Nec(E):Nec(E+1),:,7)  +[zeros(Ne(E),N*6),SESTART,Diffmodel{E,5},SEEND,zeros(Ne(E),N*5),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-13))];
R(Nec(E):Nec(E+1),:,8)=R(Nec(E):Nec(E+1),:,8)  +[zeros(Ne(E),N*2),SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,zeros(Ne(E),N*(ant-8))];
R(Nec(E):Nec(E+1),:,9)=R(Nec(E):Nec(E+1),:,9)  +[zeros(Ne(E),N*2),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DCvelconvRelaxedE{E},SEEND,zeros(Ne(E),N*(ant-9))];
R(Nec(E):Nec(E+1),:,10)=R(Nec(E):Nec(E+1),:,10)+[zeros(Ne(E),N*3),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DCvelconvRelaxedE{E},SEEND,zeros(Ne(E),N*(ant-10))];
R(Nec(E):Nec(E+1),:,11)=R(Nec(E):Nec(E+1),:,11)+[zeros(Ne(E),N*4),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DCvelconvRelaxedE{E},SEEND,zeros(Ne(E),N*(ant-11))];
R(Nec(E):Nec(E+1),:,12)=R(Nec(E):Nec(E+1),:,12)+[zeros(Ne(E),N*5),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DCvelconvRelaxedE{E},SEEND,zeros(Ne(E),N*(ant-12))];
R(Nec(E):Nec(E+1),:,13)=R(Nec(E):Nec(E+1),:,13)+[zeros(Ne(E),N*6),SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*5),SESTART,DCvelconvRelaxedE{E},SEEND,zeros(Ne(E),N*(ant-13))];
R(Nec(E):Nec(E+1),:,14)=R(Nec(E):Nec(E+1),:,14)+[zeros(Ne(E),N*8),SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,SESTART,diag(ones(Ne(E),1)),SEEND,zeros(Ne(E),N*(ant-14))];
R(Nec(E):Nec(E+1),:,15)=R(Nec(E):Nec(E+1),:,15)+[zeros(Ne(E),N*14),SESTART,diag(ones(Ne(E),1)),SEEND,zeros(Ne(E),N),SESTART,-diag(ones(Ne(E),1)/GASCONST./T(Nec(E):Nec(E+1))/Cref*Pic),SEEND,zeros(Ne(E),N*(ant-17))];
R(Nec(E):Nec(E+1),:,16)=R(Nec(E):Nec(E+1),:,16)+[zeros(Ne(E),N*14),SESTART,DCluE{E},SEEND,SESTART,diag(2./rE{E})+DE{E},SEEND,zeros(Ne(E),N*(ant-16))];
R(Nec(E):Nec(E+1),:,17)=R(Nec(E):Nec(E+1),:,17)+[zeros(Ne(E),N*16),SESTART,DE{E},SEEND,zeros(Ne(E),N*(ant-17))];
    end  
    
    
 A=[R(:,:,1);R(:,:,2);R(:,:,3);R(:,:,4);R(:,:,5);R(:,:,6);R(:,:,7);R(:,:,8);...
    R(:,:,9);R(:,:,10);R(:,:,11);R(:,:,12);R(:,:,13);R(:,:,14);R(:,:,15);R(:,:,16);R(:,:,17)];
    
%Boundary conditions in A matrix:
%Q   
A(N,1:2*N)=zeros(1,2*N);
if Tlswitch==0
    A(N,2*N)=1;
elseif Tlswitch==1
    A(N,2*N)=h; %T^*
end

%T
A(N+1,1:2*N)=zeros(1,2*N);
A(N+1,1)=1;

%MS CH4 CO CO2 H2 N2 
 for i=1:5
     A((2+i)*N,1:ant*N)=zeros(1,ant*N);
     A((2+i)*N,(8+i)*N)=1;
 end

% molefrac CH4 CO CO2 H2 N2
 for i=1:5
      A((7+i)*N+1,1:(ant*N))=zeros(1,ant*N);
      A((7+i)*N+1,(1+i)*N+1)=1;
 end
 

  %Continuity
A(15*N+1,1:ant*N)=zeros(1,ant*N);
A(15*N+1,15*N+1)=1;
  
  %darcy
A(17*N,1:ant*N)=zeros(1,ant*N);
A(17*N,17*N)=1;

%Boundary conditions in source vector
F=zeros(N*ant,1);

%----------------------------------------

%Qeq
if Tlswitch==0
    F(N)=1;
elseif Tlswitch==1
    F(N)=f(N)*lambda/Rp+C(N)*CPg(N)*T(N)/Tref*vconvrelaxed(N)*Dref/Rp+h;
end

%Teq:
for E=1:Noe
F(N+Nec(E):N+Nec(E+1))=F(N+Nec(E):N+Nec(E+1))-DELTAHr(Nec(E):Nec(E+1)).*Rp^2./Tref./lambda;
end
F(N+1)=0;

 for i=1:5
     for E=1:Noe
        F((1+i)*N+Nec(E):(1+i)*N+Nec(E+1))=F((1+i)*N+Nec(E):(1+i)*N+Nec(E+1))+Difftermsource(Nec(E):Nec(E+1),i);
     end
 end


% ki(1) = 0.079;       % CH4
% ki(2) = 0.065;       % CO
% ki(3) = 0.055;       % CO2
% ki(4) = 0.148;       % H2
% ki(5) = 0.067;       % N2
% ki(6) = 0.079;       % H2O
    
 % BC at surface
 if Tlswitch==0
    for i=1:5
    F((2+i)*N)=Yic(i);
    end
elseif Tlswitch==1
    for i=1:5
    F((2+i)*N)=((Flux(N,i)*Dref/Rp+u(N)*Dref/Rp*Cl(N)*Y(N,i))/ki(i)+Yic(i))/Cl(N);
    end
 end


%Species balance  CH4 CO CO2 H2 N2 H2O
 for i=1:5
     for E=1:Noe
        F((7+i)*N+Nec(E):(7+i)*N+Nec(E+1))=F((7+i)*N+Nec(E):(7+i)*N+Nec(E+1))+(Rcomp(Nec(E):Nec(E+1),i)-sum(Rcomp(Nec(E):Nec(E+1),:)')'.*Y(Nec(E):Nec(E+1),i))*rhop*(1-eps)*Rp^2/Cref/Dref;
     end
 end

%BC at senter
for i=1:5
F((7+i)*N+1)=0;
end

%sum fluxes:
F(7*N+1:8*N)=zeros(N,1);
%sum molfracs:
for E=1:Noe
F((13)*N+Nec(E):(13)*N+Nec(E+1))=F((13)*N+Nec(E):(13)*N+Nec(E+1))+ones(Ne(E),1);
end

%Mole base continuity
for E=1:Noe
F((15)*N+Nec(E):(15)*N+Nec(E+1))=F((15)*N+Nec(E):(15)*N+Nec(E+1))+sum(Rcomp((Nec(E):Nec(E+1)),:)')'*rhop*(1-eps)*Rp^2/Cref/Dref./Cl(Nec(E):Nec(E+1));
end
F(15*N+1)=0;

%darcy's law
for E=1:Noe
F((16)*N+Nec(E):(16)*N+Nec(E+1))=F((16)*N+Nec(E):(16)*N+Nec(E+1))-Dref.*VISg(Nec(E):Nec(E+1))./B0./Pic.*vconvrelaxed(Nec(E):Nec(E+1));
end

F(17*N)=1;

fold=f;

%solve
f=A\F;

itcount=itcount+1;


% Pulse relaxation:
% Pulse=Pulse+1;
if Pulse>100 && itcount>2000
alpha=0.04;
alphaj=1;
alphaCl=1;
alphaC=1;
alphaP=1;
f(1:N)=alpha*f(1:N)+(1-alpha)*fold(1:N);
f(N+1:2*N)=max(alpha*f(N+1:2*N)+(1-alpha)*fold(N+1:2*N),0.5);
f(2*N+1:8*N)=alphaj*f(2*N+1:8*N)+(1-alphaj)*fold(2*N+1:8*N);
f(8*N+1:14*N)=max(alpha*f(8*N+1:14*N)+(1-alpha)*fold(8*N+1:14*N),0.00001);
f(14*N+1:15*N)=max(alphaCl*f(14*N+1:15*N)+(1-alphaCl)*fold(14*N+1:15*N),0.5);
f(15*N+1:16*N)=alphaC*f(15*N+1:16*N)+(1-alphaC)*fold(15*N+1:16*N);
f(16*N+1:17*N)=max(alphaP*f(16*N+1:17*N)+(1-alphaP)*fold(16*N+1:17*N),0.5);
Pulse=1;
else

% relaxation of the iteration:
if diffmodel==1
    alpha=0.00015;
elseif diffmodel==2
    alpha=0.00010;
elseif diffmodel==3
    alpha=0.00015;
elseif diffmodel==4
    alpha=0.00010;
end
alphaj=1;
alphaCl=1;
alphaC=1;
alphaP=1;
f(1:N)=alpha*f(1:N)+(1-alpha)*fold(1:N);
f(N+1:2*N)=max(alpha*f(N+1:2*N)+(1-alpha)*fold(N+1:2*N),0.5);
f(2*N+1:8*N)=alphaj*f(2*N+1:8*N)+(1-alphaj)*fold(2*N+1:8*N);
f(8*N+1:14*N)=max(alpha*f(8*N+1:14*N)+(1-alpha)*fold(8*N+1:14*N),0.00001);
f(14*N+1:15*N)=max(alphaCl*f(14*N+1:15*N)+(1-alphaCl)*fold(14*N+1:15*N),0.5);
f(15*N+1:16*N)=alphaC*f(15*N+1:16*N)+(1-alphaC)*fold(15*N+1:16*N);
f(16*N+1:17*N)=max(alphaP*f(16*N+1:17*N)+(1-alphaP)*fold(16*N+1:17*N),0.5);
end

%update Molfracs and temperature
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Flux=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
T=f(N+1:2*N)*Tref;
Cl=f(14*N+1:15*N);
u=f(15*N+1:16*N);
Pl=f(16*N+1:17*N);

residual=sqrt((A*f-F)'*diag(w)*(A*f-F))
end

%plot results
%figure
subplot(3,3,1)
hold on
plot(r,f(N+1:2*N)*Tref,'r')
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];

for i=1:N
    W(i,:)=Y(i,:).*MMASS./((Y(i,:)*MMASS'));
end

    if Comp==1 %H2O
    elseif Comp==2%CH4
        Y=[Y(:,6),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,1)];
    elseif Comp==3%CO
        Y=[Y(:,1),Y(:,6),Y(:,3),Y(:,4),Y(:,5),Y(:,2)];
    elseif Comp==4%CO2
        Y=[Y(:,1),Y(:,2),Y(:,6),Y(:,4),Y(:,5),Y(:,3)];
    elseif Comp==5%H2
        Y=[Y(:,1),Y(:,2),Y(:,3),Y(:,6),Y(:,5),Y(:,4)];
    elseif Comp==6 %N2
        Y=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)];
    end
    
    %writeout residual & error
%Amount of time used on calucation
toc
timespent=toc
sqrt((f-fold)'*diag(w)*(f-fold))
residual=sqrt((A*f-F)'*diag(w)*(A*f-F))
itcount
    
    %save workspace:
    if Comp==1 %H2O
        if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE H2O NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS H2O NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS H2O NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty H2O NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE H2O NOTL')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS H2O NOTL')
                elseif diffmodel==3
                    save('MOLE ELEM MS H2O NOTL')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty H2O NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE H2O NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS H2O NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS H2O NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty H2O NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE H2O')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS H2O')
                elseif diffmodel==3
                    save('MOLE ELEM MS H2O')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty H2O')
                end
                        end
        end
                    
    elseif Comp==2%CH4
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE CH4 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CH4 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS CH4 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CH4 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE CH4 NOTL')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CH4 NOTL')
                elseif diffmodel==3
                    save('MOLE ELEM MS CH4 NOTL')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CH4 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE CH4 NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CH4 NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS CH4 NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CH4 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE CH4')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CH4')
                elseif diffmodel==3
                    save('MOLE ELEM MS CH4')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CH4')
                end
                        end
        end
       
    elseif Comp==3%CO
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE CO NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CO NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS CO NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CO NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE CO NOTL')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CO NOTL')
                elseif diffmodel==3
                    save('MOLE ELEM MS CO NOTL')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CO NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE CO NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CO NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS CO NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CO NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE CO')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CO')
                elseif diffmodel==3
                    save('MOLE ELEM MS CO')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CO')
                end
                        end
        end
    elseif Comp==4%CO2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE CO2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CO2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS CO2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CO2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE CO2 NOTL')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CO2 NOTL')
                elseif diffmodel==3
                    save('MOLE ELEM MS CO2 NOTL')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CO2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE CO2 NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CO2 NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS CO2 NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CO2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE CO2')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS CO2')
                elseif diffmodel==3
                    save('MOLE ELEM MS CO2')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty CO2')
                end
                        end
        end
    elseif Comp==5%H2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE H2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS H2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS H2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty H2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE H2 NOTL')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS H2 NOTL')
                elseif diffmodel==3
                    save('MOLE ELEM MS H2 NOTL')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty H2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE H2 NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS H2 NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS H2 NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty H2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE H2')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS H2')
                elseif diffmodel==3
                    save('MOLE ELEM MS H2')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty H2')
                end
                        end
        end
    elseif Comp==6 %N2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE N2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS N2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS N2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty N2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE N2 NOTL')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS N2 NOTL')
                elseif diffmodel==3
                    save('MOLE ELEM MS N2 NOTL')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty N2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE ELEM WILKE N2 NOCONV')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS N2 NOCONV')
                elseif diffmodel==3
                    save('MOLE ELEM MS N2 NOCONV')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty N2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE ELEM WILKE N2')
                elseif diffmodel==2
                    save('MOLE ELEM WILKE-BOS N2')
                elseif diffmodel==3
                    save('MOLE ELEM MS N2')
                elseif diffmodel==4
                    save('MOLE ELEM Dusty N2')
                end
                        end
        end
    end
end
end
end
end