clear all
clc
for i=1:1
Comp=i;
for j=1:1
CONVswitch=j;
for k=1:1
Tlswitch=k;
for l=3:3
diffmodel=l;

 global N  GASCONST MMASS
tic
% Comp
% CONVswitch
% Tlswitch
% diffmodel
% pause

%For loops:
% i = main component
% j = secondary component
% k = position in particle

%convective on off
% ConvSWITCH=1;% on=1 off=0

%BC - transfer limitations on off
% TlSWITCH=1;

%Diffusion model
% DIFFmodel=1;
%1=Wilke
%2=Wilke Bosanquet
%3=MS
%4=Dusty gas

%component solved by 1-sum(N-1)
% CompSOLV=1;
%1=H2O
%2=CH4
%3=CO
%4=CO2
%5=H2
%6=N2


    if Comp==1
        constantH2O
    elseif Comp==2
        constantCH4
    elseif Comp==3
        constantCO
    elseif Comp==4
        constantCO2
    elseif Comp==5
        constantH2
    elseif Comp==6
        constantN2
    end


%Colloc.m routine
[r,q]=GaussLobattoLegendre(N);
D=LagrangeDerivativeMatrix_GLL(N);
r=(r/2+0.5);
D=D*2;
q=(q/2);

%Initial Mass fractions:
Wic=Yic.*MMASS./(Yic*MMASS');

f=[zeros(N,1);ones(N,1);...
    
   zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);...
   
   ones(N,1)*Wic(1);ones(N,1)*Wic(2);ones(N,1)*Wic(3);...
   ones(N,1)*Wic(4);ones(N,1)*Wic(5);ones(N,1)*Wic(6);...
   
   zeros(N,1);ones(N,1)];
%load('Ficmass50')
%preload variables freom IC vector:
W=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Flux=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
v=[f(14*N+1:15*N)];
Pl=[f(15*N+1:16*N)];
T=f(N+1:2*N)*Tref;

ant=16;%antall ligninger

%define weights for error calculation:
w=[];
for i=1:ant
    w=[w;q];
end

fold=f;
Pulse=1;
while residual>tol %&& itcount <250

    v=v*CONVswitch;
    [VISg, vis_comp] = viscosity(T,W,N); %massfraction 
    
    
   %convert to molfrac for reaction
     for k=1:N
     Y(k,:)=W(k,:)./MMASS./sum((W(k,:)./MMASS));
     end

    %change position for the automatic reaction H20 N2
   
    if Comp==2%CH4
    Yc=[Y(:,6),Y(:,2),Y(:,3),Y(:,4),Y(:,1),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,5),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,1)];
    
    elseif Comp==3%CO
    Yc=[Y(:,1),Y(:,6),Y(:,3),Y(:,4),Y(:,2),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,5),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,2)];
    
    elseif Comp==4%CO2
    Yc=[Y(:,1),Y(:,2),Y(:,6),Y(:,4),Y(:,3),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,5),Rcomp(:,4),Rcomp(:,6),Rcomp(:,3)];
    
    elseif Comp==5%H2
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,6),Y(:,4),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,5),Rcomp(:,6),Rcomp(:,4)];
    
    elseif Comp==1 %H2O
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)]; 
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,5)];
    
    elseif Comp==6 %N2
    %change position for the automatic reaction H20 N2
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,5),Rcomp(:,6)];
    end   

    
    for k=1:N
    Rcomp(k,:)=Rcomp(k,:).*MMASS;
    end
     
%molar mass average
Mav=1./(W*(1./MMASS'));

%calculate Density of gas:
RHOgas=Pl*Pic.*Mav./GASCONST./T;
RHOgasref=Pic.*1./(Wic*(1./MMASS'))/GASCONST./Tref;
RHOgasl=RHOgas/RHOgasref;

%derivative of average molecularweight and density
DMav=D*Mav;

if diffmodel==1
    %Calculation of the Sum parts in the WILKE equations:
    sumWrMwrDsr=zeros(N,6);
    sumJMwrDsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                sumWrMwrDsr(k,i)=sumWrMwrDsr(k,i)+W(k,j)/Diff(i,j)/MMASS(j)*Mav(k)/(1-W(k,i));
                 end
             end
         end
    end

    %defining Da and the derivative of DA
Ds=1./sumWrMwrDsr;
Dref=Ds(N,3);
%Calculation of the Sum parts in the WILKE equations:
 for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     
                     sumJMwrDsr(k,i)=sumJMwrDsr(k,i)+Flux(k,j)*Dref/Diff(i,j)/MMASS(j)*Mav(k)*W(k,i);
                  end
             end
         end
 end
  for i=1:6
 Difftermcolloc{i}=diag(Dref./Ds(:,i)./RHOgasl);
 end
 Difftermsource=zeros(N,6);
 
elseif diffmodel==2
    %Calculation of the Sum parts in the WILKE-BOS equations:
    sumWrMwrDsr=zeros(N,6);
    sumJMwrDsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                sumWrMwrDsr(k,i)=sumWrMwrDsr(k,i)+W(k,j)/Diff(i,j)/MMASS(j)*Mav(k)/(1-W(k,i));
                 end
             end
         end
    end
for i=1:6
    Dk(:,i)=48.5*dpore*(T/MMASS(i)).^0.5*eps/tau;
end 
    
    %defining Da and the derivative of DA
Dim=1./sumWrMwrDsr;
Dsinv=1./Dim+1./Dk;
Ds=1./Dsinv;
Dref=Ds(N,3);
%Calculation of the Sum parts in the WILKE-BOS equations:
 for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     
                     sumJMwrDsr(k,i)=sumJMwrDsr(k,i)+Flux(k,j)*Dref/Diff(i,j)/MMASS(j)*Mav(k)*W(k,i);
                  end
             end
         end
 end
  for i=1:6
 Difftermcolloc{i}=diag(Dref./Ds(:,i)./RHOgasl);
 end
 Difftermsource=zeros(N,6);
elseif diffmodel==3
    %Calculation of the Sum parts in the MS equations:
    sumWrMwrDsr=zeros(N,6);
    sumJMwrDsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumWrMwrDsr(k,i)=sumWrMwrDsr(k,i)+W(k,j)/Diff(i,j)/MMASS(j)*Mav(k);
                 end
             end
         end
    end

    %defining Da and the derivative of DA
Ds=1./sumWrMwrDsr;
Dref=Ds(N,3);
%Calculation of the Sum parts in the MS equations:
 for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     
                     sumJMwrDsr(k,i)=sumJMwrDsr(k,i)+Flux(k,j)*Dref/Diff(i,j)/MMASS(j)*Mav(k)*W(k,i);
                  end
             end
         end
 end
 for i=1:6
 Difftermcolloc{i}=diag(Dref./Ds(:,i)./RHOgasl);
 end
 for i=1:6
     for k=1:N
 Difftermsource(k,i)=-1/Mav(k)*DMav(k)*W(k,i)+RHOgasref/RHOgas(k)*sumJMwrDsr(k,i);
     end
 end
elseif diffmodel==4
    %knudsen diffusion:
%http://www.springerlink.com/content/3r71012k1u2t2766/
for i=1:6
    Dk(:,i)=48.5*dpore*(T/MMASS(i)).^0.5*eps/tau;
end
%Calculation of the Sum parts in the DUSTYGAS equations:
    sumWrMwrDsr=zeros(N,6);
    sumJMwrDsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumWrMwrDsr(k,i)=sumWrMwrDsr(k,i)+W(k,j)/Diff(i,j)/MMASS(j)*Mav(k);
                 end
             end
             sumWrMwrDsr(k,i)=sumWrMwrDsr(k,i)+1/Dk(k,i);
         end
    end

    %defining Da and the derivative of DA
Ds=1./sumWrMwrDsr;
Dref=Ds(N,3);
%Calculation of the Sum parts in the DUSTYGAS equations:
 for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     
                     sumJMwrDsr(k,i)=sumJMwrDsr(k,i)+Flux(k,j)*Dref/Diff(i,j)/MMASS(j)*Mav(k)*W(k,i);
                  end
             end
         end
 end
  for i=1:6
 Difftermcolloc{i}=diag(Dref./Ds(:,i)./RHOgasl);
 end
 for i=1:6
     for k=1:N
 Difftermsource(k,i)=sumJMwrDsr(k,i)/RHOgasl(k)-W(k,i)/Mav(k)*DMav(k)-v(k)*Dref*W(k,i)/RHOgasl(k)/Dk(k,i);
     end
 end
end


    CPg = Heat_capacity(Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6),T);
     

for k=1:N
    % Convective term species balance
    Dwvrho(k,:)=D(k,:)*v(k)*RHOgasl(k);
    % Convective term Temperature balance
    Dtemp(k,:)=D(k,:)*Dref/lambda*v(k)*RHOgasl(k)*RHOgasref*CPg(k);
end

% Gather the A matrix 
     A=[...
        diag(ones(N,1))   ,    D         , zeros(N,N*(ant-2));...                           % Q equation 1 fouriers law
        diag(2./r)+D      , Dtemp   , zeros(N,N*(ant-2));...                           % T equation 2
        zeros(N,2*N) , Difftermcolloc{1} , zeros(N,5*N) , D ,     zeros(N,N*(ant-9));...      %MS CH4 
        zeros(N,3*N) , Difftermcolloc{2} , zeros(N,5*N) , D ,     zeros(N,N*(ant-10));...     %MS CO
        zeros(N,4*N) , Difftermcolloc{3} , zeros(N,5*N) , D ,     zeros(N,N*(ant-11));...     %MS CO2    X
        zeros(N,5*N) , Difftermcolloc{4} , zeros(N,5*N) , D ,     zeros(N,N*(ant-12));...     %MS H2
        zeros(N,6*N) , Difftermcolloc{5} , zeros(N,5*N) , D ,     zeros(N,N*(ant-13));...     %MS N2
        zeros(N,2*N) , diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), zeros(N,N*(ant-8));...
        zeros(N,2*N) ,  D+diag(2./r)   , zeros(N,5*N) ,Dwvrho, zeros(N,N*(ant-9));... %Molfrac CH4 10       J
        zeros(N,3*N) ,  D+diag(2./r)   , zeros(N,5*N) ,Dwvrho, zeros(N,N*(ant-10));...%Molfrac CO
        zeros(N,4*N) ,  D+diag(2./r)   , zeros(N,5*N) ,Dwvrho, zeros(N,N*(ant-11));...%Molfrac CO2
        zeros(N,5*N) ,  D+diag(2./r)   , zeros(N,5*N) ,Dwvrho, zeros(N,N*(ant-12));...%Molfrac H2
        zeros(N,6*N) ,  D+diag(2./r)   , zeros(N,5*N) ,Dwvrho, zeros(N,N*(ant-13));...%Molfrac N2
        zeros(N,8*N) , diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)),zeros(N,N*(ant-14));...
        zeros(N,14*N),  D+diag(2./r), zeros(N,N*(ant-15));...
        zeros(N,14*N), diag(Dref.*VISg/B0/Pic),D];...
%Boundary conditions in A matrix:
%Q   
A(N,1:2*N)=zeros(1,2*N);
if Tlswitch==0
    A(N,2*N)=1;
elseif Tlswitch==1
    A(N,2*N)=h; %T^*
end

%T
A(N+1,1:2*N)=zeros(1,2*N);
A(N+1,1)=1;

%MS CH4 CO CO2 H2 N2 
 for i=1:5
 A((2+i)*N,1:ant*N)=zeros(1,ant*N);
 A((2+i)*N,(8+i)*N)=1;
 end

% molefrac CH4 CO CO2 H2 N2
 for i=1:5
      A((7+i)*N+1,1:(ant*N))=zeros(1,ant*N);
      A((7+i)*N+1,(1+i)*N+1)=1;
 end

 %Cont
A(14*N+1,1:ant*N)=zeros(1,ant*N);
A(14*N+1,14*N+1)=1;

A(16*N,1:ant*N)=zeros(1,ant*N);
A(16*N,16*N)=1;
 
%Boundary conditions in source vector
F=zeros(N*ant,1);

%------------------------------------------------------

%Qeq
if Tlswitch==0
    F(N)=1;
elseif Tlswitch==1
    F(N)=f(N)*lambda/Rp+RHOgas(N)*CPg(N)*T(N)/Tref*v(N)*Dref/Rp+h;
end

%Teq:
F(N+1:2*N)=-DELTAHr.*Rp^2./Tref./lambda;
F(N+1)=0;


% Diffusion model source terms:
 for i=1:5
     for k=1:N
     F((1+i)*N+k)=Difftermsource(k,i);
     end
 end
 

 % BC at surface diffusive equations:
 if Tlswitch==0
    for i=1:5
    F((2+i)*N)=Wic(i);
    end
elseif Tlswitch==1
    for i=1:5
    F((2+i)*N)=((Flux(N,i)*Dref/Rp+v(N)*Dref/Rp*RHOgasl(N)*W(N,i))/ki(i)+Wic(i))/RHOgasl(N);
    end
 end

%J eq CH4 CO CO2 H2
for i=1:5
        F((7+i)*N+1:(8+i)*N)=Rcomp(:,i)*rhop*(1-eps)*Rp^2/RHOgasref/Dref;
end



%BC at senter
for i=1:5
F((7+i)*N+1)=0;
end

%sum fluxes:
F(7*N+1:8*N)=zeros(N,1);
%sum molfracs:
F(13*N+1:14*N)=ones(N,1);

%continuity
F(14*N+1:15*N)=-(D*RHOgasl).*v./RHOgasl;
F(14*N+1)=0;

%darcy's law
F(16*N)=1; 

fold=f;



%solve
f=A\F;



itcount=itcount+1;

% Pulse relaxation:
Pulse=Pulse+1;
if Pulse>100 && itcount>1000
alpha=0.05;
alphaj=1;
f(1:N)=alpha*f(1:N)+(1-alpha)*fold(1:N);
f(N+1:2*N)=(alphaj*f(N+1:2*N)+(1-alphaj)*fold(N+1:2*N));
f(2*N+1:8*N)=alphaj*f(2*N+1:8*N)+(1-alphaj)*fold(2*N+1:8*N);
f(8*N+1:14*N)=max(alpha*f(8*N+1:14*N)+(1-alpha)*fold(8*N+1:14*N),0.000000000001);
Pulse=1;
else

% relaxation of the iteration:
alpha=0.0002;
alphaj=1;

f(1:N)=alpha*f(1:N)+(1-alpha)*fold(1:N);
f(N+1:2*N)=(alphaj*f(N+1:2*N)+(1-alphaj)*fold(N+1:2*N));
f(2*N+1:8*N)=alphaj*f(2*N+1:8*N)+(1-alphaj)*fold(2*N+1:8*N);
f(8*N+1:14*N)=max(alpha*f(8*N+1:14*N)+(1-alpha)*fold(8*N+1:14*N),0.000000000001);
end
%update Molfracs and temperature and gather fluxes
W=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Flux=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
v=[f(14*N+1:15*N)];
Pl=[f(15*N+1:16*N)];
T=f(N+1:2*N)*Tref;

%residual
residual=sqrt((A*f-F)'*diag(w)*(A*f-F))
end
r=r*Rp;

%convert to molfrac for plotting
     for i=1:N
     Y(i,:)=W(i,:)./MMASS./sum((W(i,:)./MMASS));
     end

     u=zeros(N,1);
for i=1:6
        u=u+Flux(:,i).*Mav/MMASS(i)./RHOgasl;
end
u=u+v;

    if Comp==1 %H2O
    elseif Comp==2%CH4
        Y=[Y(:,6),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,1)];
    elseif Comp==3%CO
        Y=[Y(:,1),Y(:,6),Y(:,3),Y(:,4),Y(:,5),Y(:,2)];
    elseif Comp==4%CO2
        Y=[Y(:,1),Y(:,2),Y(:,6),Y(:,4),Y(:,5),Y(:,3)];
    elseif Comp==5%H2
        Y=[Y(:,1),Y(:,2),Y(:,3),Y(:,6),Y(:,5),Y(:,4)];
    elseif Comp==6 %N2
        Y=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)];
    end

%save workspace:
    if Comp==1 %H2O
        if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE H2O NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS H2O NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS MS H2O NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty H2O NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE H2O NOTL')
                elseif diffmodel==2
                    save('MASS WILKE-BOS H2O NOTL')
                elseif diffmodel==3
                    save('MASS MS H2O NOTL')
                elseif diffmodel==4
                    save('MASS Dusty H2O NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE H2O NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS H2O NOCONV')
                elseif diffmodel==3
                    save('MASS MS H2O NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty H2O NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE H2O')
                elseif diffmodel==2
                    save('MASS WILKE-BOS H2O')
                elseif diffmodel==3
                    save('MASS MS H2O')
                elseif diffmodel==4
                    save('MASS Dusty H2O')
                end
                        end
        end
                    
    elseif Comp==2%CH4
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE CH4 NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CH4 NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS MS CH4 NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty CH4 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE CH4 NOTL')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CH4 NOTL')
                elseif diffmodel==3
                    save('MASS MS CH4 NOTL')
                elseif diffmodel==4
                    save('MASS Dusty CH4 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE CH4 NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CH4 NOCONV')
                elseif diffmodel==3
                    save('MASS MS CH4 NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty CH4 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE CH4')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CH4')
                elseif diffmodel==3
                    save('MASS MS CH4')
                elseif diffmodel==4
                    save('MASS Dusty CH4')
                end
                        end
        end
       
    elseif Comp==3%CO
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE CO NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CO NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS MS CO NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty CO NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE CO NOTL')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CO NOTL')
                elseif diffmodel==3
                    save('MASS MS CO NOTL')
                elseif diffmodel==4
                    save('MASS Dusty CO NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE CO NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CO NOCONV')
                elseif diffmodel==3
                    save('MASS MS CO NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty CO NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE CO')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CO')
                elseif diffmodel==3
                    save('MASS MS CO')
                elseif diffmodel==4
                    save('MASS Dusty CO')
                end
                        end
        end
    elseif Comp==4%CO2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE CO2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CO2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS MS CO2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty CO2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE CO2 NOTL')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CO2 NOTL')
                elseif diffmodel==3
                    save('MASS MS CO2 NOTL')
                elseif diffmodel==4
                    save('MASS Dusty CO2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE CO2 NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CO2 NOCONV')
                elseif diffmodel==3
                    save('MASS MS CO2 NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty CO2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE CO2')
                elseif diffmodel==2
                    save('MASS WILKE-BOS CO2')
                elseif diffmodel==3
                    save('MASS MS CO2')
                elseif diffmodel==4
                    save('MASS Dusty CO2')
                end
                        end
        end
    elseif Comp==5%H2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE H2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS H2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS MS H2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty H2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE H2 NOTL')
                elseif diffmodel==2
                    save('MASS WILKE-BOS H2 NOTL')
                elseif diffmodel==3
                    save('MASS MS H2 NOTL')
                elseif diffmodel==4
                    save('MASS Dusty H2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE H2 NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS H2 NOCONV')
                elseif diffmodel==3
                    save('MASS MS H2 NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty H2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE H2')
                elseif diffmodel==2
                    save('MASS WILKE-BOS H2')
                elseif diffmodel==3
                    save('MASS MS H2')
                elseif diffmodel==4
                    save('MASS Dusty H2')
                end
                        end
        end
    elseif Comp==6 %N2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE N2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS N2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MASS MS N2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty N2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE N2 NOTL')
                elseif diffmodel==2
                    save('MASS WILKE-BOS N2 NOTL')
                elseif diffmodel==3
                    save('MASS MS N2 NOTL')
                elseif diffmodel==4
                    save('MASS Dusty N2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MASS WILKE N2 NOCONV')
                elseif diffmodel==2
                    save('MASS WILKE-BOS N2 NOCONV')
                elseif diffmodel==3
                    save('MASS MS N2 NOCONV')
                elseif diffmodel==4
                    save('MASS Dusty N2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MASS WILKE N2')
                elseif diffmodel==2
                    save('MASS WILKE-BOS N2')
                elseif diffmodel==3
                    save('MASS MS N2')
                elseif diffmodel==4
                    save('MASS Dusty N2')
                end
                        end
        end
 end
    %reset residual & itcount & solution vector;
residual=1;
itcount=0;
Flux=zeros(N,6);


%writeout residual & error
%Amount of time used on calucation
toc
sqrt((f-fold)'*diag(w)*(f-fold))
residual=sqrt((A*f-F)'*diag(w)*(A*f-F))
itcount
%end
end
end
end
end
