clear all
clc
for i=1:1
Comp=i;
for j=1:1
CONVswitch=j;
for k=1:1
Tlswitch=k;
for l=3:3
diffmodel=l;
tic
global N  GASCONST MMASS

%For loops:
% i = main component
% j = secondary component
% k = position in particle

%convective on off
% ConvSWITCH=1;% on=1 off=0

%BC - transfer limitations on off
% TlSWITCH=1;

%Diffusion model
% DIFFmodel=1;
%1=Wilke
%2=Wilke Bosanquet
%3=MS
%4=Dusty gas

%component solved by 1-sum(N-1)
% CompSOLV=1;
%1=CH4
%2=CO2
%3=CO
%4=H2
%5=N2
%6=H2O

    if Comp==1
        constantH2O
    elseif Comp==2
        constantCH4
    elseif Comp==3
        constantCO
    elseif Comp==4
        constantCO2
    elseif Comp==5
        constantH2
    elseif Comp==6
        constantN2
    end

 
%Colloc.m routine
[r,q]=GaussLobattoLegendre(N);
D=LagrangeDerivativeMatrix_GLL(N);
r=(r/2+0.5);
D=D*2;
q=(q/2);


f=[zeros(N,1);ones(N,1);... %temperature and
    %Fluxes
  zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);zeros(N,1);...
    %Species balance
  ones(N,1)*Yic(1);ones(N,1)*Yic(2);ones(N,1)*Yic(3);...
  ones(N,1)*Yic(4);ones(N,1)*Yic(5);ones(N,1)*Yic(6);...
    %Ideal gas law, Continuity, Darcys law
  ones(N,1);ones(N,1)*10^-6;ones(N,1)];

% load('Ficmole')

%preload variables freom IC vector:
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Flux=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
T=f(N+1:2*N)*Tref;
Cl=f(14*N+1:15*N);
u=f(15*N+1:16*N);
Pl=f(16*N+1:17*N);



fold=f;

%inital molefractions
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];

ant=17;%equations in the main matrix

%define weights for error calculation:
w=[];
for i=1:ant
    w=[w;q];
end
Pulse=1;
while residual>tol %&& itcount <500

    u=u*CONVswitch;
       %change position for the automatic reaction H20 N2
   
    if Comp==2%CH4
    Yc=[Y(:,6),Y(:,2),Y(:,3),Y(:,4),Y(:,1),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,5),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,1)];
    
    elseif Comp==3%CO
    Yc=[Y(:,1),Y(:,6),Y(:,3),Y(:,4),Y(:,2),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,5),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,2)];
    
    elseif Comp==4%CO2
    Yc=[Y(:,1),Y(:,2),Y(:,6),Y(:,4),Y(:,3),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,5),Rcomp(:,4),Rcomp(:,6),Rcomp(:,3)];
    
    elseif Comp==5%H2
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,6),Y(:,4),Y(:,5)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,5),Rcomp(:,6),Rcomp(:,4)];
    
    elseif Comp==1 %H2O
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)]; 
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,6),Rcomp(:,5)];
    
    elseif Comp==6 %N2
    %change position for the automatic reaction H20 N2
    Yc=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6)];
    %calculate reaction rate and heat, Constant pressure
    [Rcomp,DELTAHr] = reaction(T,Yc,Pic*Pl); 
    %change order of components
    Rcomp=[Rcomp(:,1),Rcomp(:,2),Rcomp(:,3),Rcomp(:,4),Rcomp(:,5),Rcomp(:,6)];
    end  
    
%calculate cocentration:
Mav=Y*MMASS';
C=Cref*Cl;

if diffmodel==1
    %Calculation of the Sum parts in the WILKE equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j)/(1-Y(k,i));
                 end
             end
         end
    end
    
   %Define Ds and Dref
    Ds=1./sumwrmwrdsr;
    Dref=Ds(N,3);
     
 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
  for i=1:6
 Difftermcolloc{i}=diag(Dref./Ds(:,i)./Cl);
 end
 Difftermsource=zeros(N,6);
 
elseif diffmodel==2
    %Calculation of the Sum parts in the WILKE-BOS equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j)/(1-Y(k,i));
                 end
             end
         end
    end
    
   %Define Ds and Dref
       %knudsen diffusion:
%http://www.springerlink.com/content/3r71012k1u2t2766/
   for i=1:6
    Dk(:,i)=48.5*dpore*(T/MMASS(i)).^0.5*eps/tau;
end 
   
Dim=1./sumwrmwrdsr;
Dsinv=1./Dim+1./Dk;
Ds=1./Dsinv;
Dref=Ds(N,3);
     
 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
  for i=1:6
 Difftermcolloc{i}=diag(Dref./Ds(:,i)./Cl);
 end
 Difftermsource=zeros(N,6);
elseif diffmodel==3
%Calculation of the Sum parts in the MS equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j);
                 end
             end
         end
    end
    
   %Define Ds and Dref
    Ds=1./sumwrmwrdsr;
    Dref=Ds(N,3);

 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
 for i=1:6
 Difftermcolloc{i}=diag(Dref./Ds(:,i)./Cl);
 end
 for i=1:6
     for k=1:N
 Difftermsource(k,i)=sumjrmwrdsr(k,i)*Cref/C(k);
     end
 end
elseif diffmodel==4
%knudsen diffusion:
%http://www.springerlink.com/content/3r71012k1u2t2766/
for i=1:6
    Dk(:,i)=48.5*dpore*(T/MMASS(i)).^0.5*eps/tau;
end

%Calculation of the Sum parts in the MS equations:
    sumwrmwrdsr=zeros(N,6);
    sumjrmwrdsr=zeros(N,6);
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+Y(k,j)/Diff(i,j);
                 end
             end
             sumwrmwrdsr(k,i)=sumwrmwrdsr(k,i)+1/Dk(k,i);
         end
    end
    
   %Define Ds and Dref
    Ds=1./sumwrmwrdsr;
    Dref=Ds(N,3);

       
 %Calculation of the Sum parts in the MS equations:     
    for k=1:N  
        [Diff]=diffcoef(T(k),Pic*Pl(k));
         for i=1:6
             for j=1:6
                 if j==i
                 else
                     sumjrmwrdsr(k,i)=sumjrmwrdsr(k,i)+Dref*Flux(k,j)/Diff(i,j)*Y(k,i);
                 end
             end
         end
    end
  for i=1:6
 Difftermcolloc{i}=diag(Dref./Ds(:,i)./Cl);
 end
 for i=1:6
     for k=1:N
 Difftermsource(k,i)=sumjrmwrdsr(k,i)/Cl(k)-Y(k,i)*u(k)/Dk(k,i)*Dref;
     end
 end
end


% convective terms  
% conv velocity

for i=1:N
W(i,:)=Y(i,:).*MMASS./((Y(i,:)*MMASS'));
end 
[VISg, vis_comp] = viscosity(T,W,N); %massfraction


%Calculate molar velocity converted from fluxes:
velconv=zeros(N,1);
 for i=1:6
     velconv=velconv+Flux(:,i)*MMASS(i)./Mav./Cl;
 end
%relaxation needed for the convective term
vconv=velconv+u;
vconv=vconv*CONVswitch;
alpha=0.01;
vconvrelaxed=vconv*alpha+(1-alpha)*vconvrelaxed;

 
 %Calculate average CP for gas:
 CPg = Heat_capacitymol(Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,6),T);
 %---------
 
 %Convective/derivative terms:
 for k=1:N
     %Convective term Temperature equation:
     Dtemp(k,:)=D(k,:)*Dref/lambda*vconvrelaxed(k)*Cl(k)*Cref*CPg(k);
     
     %dimensionless RHO from ideal gas law
     DPRT2(k,:)=D(k,:)*Pl(k)*Pic/Cref/T(k)^2/GASCONST*Tref;
     DRT(k,:)=D(k,:)/GASCONST/T(k)*Pic/Cref;
     
     %Molar continuity:
     DClu(k,:)=D(k,:)*u(k)/Cl(k);

     %Convective term species mole balance
     DCvelconv(k,:)=D(k,:)*Cl(k)*u(k);
     
 end

%relaxation needed for the convective term
alphatest=0.001;
DCvelconvRelaxed=DCvelconv*alphatest+(1-alphatest)*DCvelconvRelaxed;
    
    % Main matrix
     A=[...
        diag(ones(N,1))   ,    D        , zeros(N,N*(ant-2));...                           % Q equation 1 fouriers law
        diag(2./r)+D      , Dtemp  , zeros(N,N*(ant-2));...                           % T equation 2
        zeros(N,2*N) , Difftermcolloc{1}  ,  zeros(N,5*N) , D ,     zeros(N,N*(ant-9));...      %MS CH4 
        zeros(N,3*N) , Difftermcolloc{2}  ,  zeros(N,5*N) , D ,     zeros(N,N*(ant-10));...     %MS CO
        zeros(N,4*N) , Difftermcolloc{3}  ,  zeros(N,5*N) , D ,     zeros(N,N*(ant-11));...     %MS CO2    X
        zeros(N,5*N) , Difftermcolloc{4}  ,  zeros(N,5*N) , D ,     zeros(N,N*(ant-12));...     %MS H2
        zeros(N,6*N) , Difftermcolloc{5}  ,  zeros(N,5*N) , D ,     zeros(N,N*(ant-13));...     %MS N2
        zeros(N,2*N) , diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), zeros(N,N*(ant-8));...
        zeros(N,2*N) ,  D+diag(2./r)   ,  zeros(N,5*N),DCvelconvRelaxed , zeros(N,N*(ant-9));... %Molfrac CH4 10       J
        zeros(N,3*N) ,  D+diag(2./r)   ,  zeros(N,5*N),DCvelconvRelaxed , zeros(N,N*(ant-10));...%Molfrac CO
        zeros(N,4*N) ,  D+diag(2./r)   ,  zeros(N,5*N),DCvelconvRelaxed , zeros(N,N*(ant-11));...%Molfrac CO2
        zeros(N,5*N) ,  D+diag(2./r)   ,  zeros(N,5*N),DCvelconvRelaxed , zeros(N,N*(ant-12));...%Molfrac H2
        zeros(N,6*N) ,  D+diag(2./r)   ,  zeros(N,5*N),DCvelconvRelaxed , zeros(N,N*(ant-13));...%Molfrac N2
        zeros(N,8*N) , diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)), diag(ones(N,1)),zeros(N,N*(ant-14));...
        zeros(N,N)   , zeros(N,13*N), diag(ones(N,1)) ,zeros(N,N), -diag(ones(N,1)/GASCONST./T/Cref*Pic),zeros(N,N*(ant-17));...
        zeros(N,14*N), DClu ,D+diag(2./r),zeros(N,N*(ant-16)) ;...
        zeros(N,15*N), zeros(N,N) , D ,zeros(N,N*(ant-17))];...
%Boundary conditions in A matrix:
%Q   
A(N,1:2*N)=zeros(1,2*N);
if Tlswitch==0
    A(N,2*N)=1;
elseif Tlswitch==1
    A(N,2*N)=h; %T^*
end

%T
A(N+1,1:2*N)=zeros(1,2*N);
A(N+1,1)=1;

%MS CH4 CO CO2 H2 N2 
 for i=1:5
     A((2+i)*N,1:ant*N)=zeros(1,ant*N);
     A((2+i)*N,(8+i)*N)=1;
 end

% molefrac CH4 CO CO2 H2 N2
 for i=1:5
      A((7+i)*N+1,1:(ant*N))=zeros(1,ant*N);
      A((7+i)*N+1,(1+i)*N+1)=1;
 end
 

  %Continuity
A(15*N+1,1:ant*N)=zeros(1,ant*N);
A(15*N+1,15*N+1)=1;
  
  %darcy
A(17*N,1:ant*N)=zeros(1,ant*N);
A(17*N,17*N)=1;

%Boundary conditions in source vector
F=zeros(N*ant,1);

%----------------------------------------

%Qeq
if Tlswitch==0
    F(N)=1;
elseif Tlswitch==1
    F(N)=f(N)*lambda/Rp+C(N)*CPg(N)*T(N)/Tref*vconv(N)*Dref/Rp+h;
end

%Teq:
F(N+1:2*N)=-DELTAHr.*Rp^2./Tref./lambda;
F(N+1)=0;

% Maxwellstefan
 for i=1:5
     for k=1:N
     F((1+i)*N+k)=Difftermsource(k,i);
     end
 end


ki(1) = 0.079;       % CH4
ki(2) = 0.065;       % CO
ki(3) = 0.055;       % CO2
ki(4) = 0.148;       % H2
ki(5) = 0.067;       % N2
ki(6) = 0.079;       % H2O
    
 % BC at surface
 if Tlswitch==0
    for i=1:5
    F((2+i)*N)=Yic(i);
    end
elseif Tlswitch==1
    for i=1:5
    F((2+i)*N)=((Flux(N,i)*Dref/Rp+u(N)*Dref/Rp*Cl(N)*Y(N,i))/ki(i)+Yic(i))/Cl(N);
    end
 end


%J eq CH4 CO CO2 H2 N2 H2O
for i=1:5
    for k=1:N
        F((7+i)*N+k)=(Rcomp(k,i)-sum(Rcomp(k,:)')*Y(k,i))*rhop*(1-eps)*Rp^2/Cref/Dref;
    end
end

%BC at senter
for i=1:5
F((7+i)*N+1)=0;
end

F(7*N+1:8*N)=zeros(N,1);
F(13*N+1:14*N)=ones(N,1);

%ideal gas law
% F(15*N)=1;

%molecont
for k=1:N
    F(15*N+k)=sum(Rcomp(k,:)')*rhop*(1-eps)*Rp^2/Cref/Dref/Cl(k);
end

F(15*N+1)=0;
for k=1:N
F(16*N+k)=-Dref*VISg(k)/B0/Pic*vconvrelaxed(k);
end
F(17*N)=1;

fold=f;

%solve
f=A\F;

itcount=itcount+1;


% Pulse relaxation:
Pulse=Pulse+1;
if Pulse>100 && itcount>1000
alpha=0.05;
alphaj=1;
alphaCl=1;
alphaC=1;
alphaP=1;
f(1:N)=alpha*f(1:N)+(1-alpha)*fold(1:N);
f(N+1:2*N)=max(alpha*f(N+1:2*N)+(1-alpha)*fold(N+1:2*N),0.5);
f(2*N+1:8*N)=alphaj*f(2*N+1:8*N)+(1-alphaj)*fold(2*N+1:8*N);
f(8*N+1:14*N)=max(alpha*f(8*N+1:14*N)+(1-alpha)*fold(8*N+1:14*N),0.00001);
f(14*N+1:15*N)=max(alphaCl*f(14*N+1:15*N)+(1-alphaCl)*fold(14*N+1:15*N),0.5);
f(15*N+1:16*N)=alphaC*f(15*N+1:16*N)+(1-alphaC)*fold(15*N+1:16*N);
f(16*N+1:17*N)=max(alphaP*f(16*N+1:17*N)+(1-alphaP)*fold(16*N+1:17*N),0.5);
Pulse=1;
else

% relaxation of the iteration:
alpha=0.0002;
alphaj=1;
alphaCl=1;
alphaC=1;
alphaP=1;
f(1:N)=alpha*f(1:N)+(1-alpha)*fold(1:N);
f(N+1:2*N)=max(alpha*f(N+1:2*N)+(1-alpha)*fold(N+1:2*N),0.5);
f(2*N+1:8*N)=alphaj*f(2*N+1:8*N)+(1-alphaj)*fold(2*N+1:8*N);
f(8*N+1:14*N)=max(alpha*f(8*N+1:14*N)+(1-alpha)*fold(8*N+1:14*N),0.00001);
f(14*N+1:15*N)=max(alphaCl*f(14*N+1:15*N)+(1-alphaCl)*fold(14*N+1:15*N),0.5);
f(15*N+1:16*N)=alphaC*f(15*N+1:16*N)+(1-alphaC)*fold(15*N+1:16*N);
f(16*N+1:17*N)=max(alphaP*f(16*N+1:17*N)+(1-alphaP)*fold(16*N+1:17*N),0.5);
end

%update Molfracs and temperature
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];
Flux=[f(2*N+1:3*N),f(3*N+1:4*N),f(4*N+1:5*N),f(5*N+1:6*N),f(6*N+1:7*N),f(7*N+1:8*N)];
T=f(N+1:2*N)*Tref;
Cl=f(14*N+1:15*N);
u=f(15*N+1:16*N);
Pl=f(16*N+1:17*N);

residual=sqrt((A*f-F)'*diag(w)*(A*f-F))
end

%plot results
%figure
r=r*Rp;
subplot(3,3,1)
hold on
plot(r,f(N+1:2*N)*Tref,'r')
Y=[f(8*N+1:9*N),f(9*N+1:10*N),f(10*N+1:11*N),f(11*N+1:12*N),f(12*N+1:13*N),f(13*N+1:14*N)];

for i=1:N
    W(i,:)=Y(i,:).*MMASS./((Y(i,:)*MMASS'));
end

    if Comp==1 %H2O
    elseif Comp==2%CH4
        Y=[Y(:,6),Y(:,2),Y(:,3),Y(:,4),Y(:,5),Y(:,1)];
    elseif Comp==3%CO
        Y=[Y(:,1),Y(:,6),Y(:,3),Y(:,4),Y(:,5),Y(:,2)];
    elseif Comp==4%CO2
        Y=[Y(:,1),Y(:,2),Y(:,6),Y(:,4),Y(:,5),Y(:,3)];
    elseif Comp==5%H2
        Y=[Y(:,1),Y(:,2),Y(:,3),Y(:,6),Y(:,5),Y(:,4)];
    elseif Comp==6 %N2
        Y=[Y(:,1),Y(:,2),Y(:,3),Y(:,4),Y(:,6),Y(:,5)];
    end
    
    %writeout residual & error
%Amount of time used on calucation
toc
sqrt((f-fold)'*diag(w)*(f-fold))
residual=sqrt((A*f-F)'*diag(w)*(A*f-F))
itcount
    
    %save workspace:
    if Comp==1 %H2O
        if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE H2O NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS H2O NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE MS H2O NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty H2O NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE H2O NOTL')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS H2O NOTL')
                elseif diffmodel==3
                    save('MOLE MS H2O NOTL')
                elseif diffmodel==4
                    save('MOLE Dusty H2O NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE H2O NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS H2O NOCONV')
                elseif diffmodel==3
                    save('MOLE MS H2O NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty H2O NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE H2O')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS H2O')
                elseif diffmodel==3
                    save('MOLE MS H2O')
                elseif diffmodel==4
                    save('MOLE Dusty H2O')
                end
                        end
        end
                    
    elseif Comp==2%CH4
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE CH4 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CH4 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE MS CH4 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty CH4 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE CH4 NOTL')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CH4 NOTL')
                elseif diffmodel==3
                    save('MOLE MS CH4 NOTL')
                elseif diffmodel==4
                    save('MOLE Dusty CH4 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE CH4 NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CH4 NOCONV')
                elseif diffmodel==3
                    save('MOLE MS CH4 NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty CH4 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE CH4')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CH4')
                elseif diffmodel==3
                    save('MOLE MS CH4')
                elseif diffmodel==4
                    save('MOLE Dusty CH4')
                end
                        end
        end
       
    elseif Comp==3%CO
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE CO NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CO NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE MS CO NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty CO NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE CO NOTL')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CO NOTL')
                elseif diffmodel==3
                    save('MOLE MS CO NOTL')
                elseif diffmodel==4
                    save('MOLE Dusty CO NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE CO NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CO NOCONV')
                elseif diffmodel==3
                    save('MOLE MS CO NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty CO NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE CO')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CO')
                elseif diffmodel==3
                    save('MOLE MS CO')
                elseif diffmodel==4
                    save('MOLE Dusty CO')
                end
                        end
        end
    elseif Comp==4%CO2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE CO2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CO2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE MS CO2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty CO2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE CO2 NOTL')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CO2 NOTL')
                elseif diffmodel==3
                    save('MOLE MS CO2 NOTL')
                elseif diffmodel==4
                    save('MOLE Dusty CO2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE CO2 NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CO2 NOCONV')
                elseif diffmodel==3
                    save('MOLE MS CO2 NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty CO2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE CO2')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS CO2')
                elseif diffmodel==3
                    save('MOLE MS CO2')
                elseif diffmodel==4
                    save('MOLE Dusty CO2')
                end
                        end
        end
    elseif Comp==5%H2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE H2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS H2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE MS H2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty H2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE H2 NOTL')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS H2 NOTL')
                elseif diffmodel==3
                    save('MOLE MS H2 NOTL')
                elseif diffmodel==4
                    save('MOLE Dusty H2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE H2 NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS H2 NOCONV')
                elseif diffmodel==3
                    save('MOLE MS H2 NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty H2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE H2')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS H2')
                elseif diffmodel==3
                    save('MOLE MS H2')
                elseif diffmodel==4
                    save('MOLE Dusty H2')
                end
                        end
        end
    elseif Comp==6 %N2
if Tlswitch==0
            if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE N2 NOTL NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS N2 NOTL NOCONV')
                elseif diffmodel==3
                    save('MOLE MS N2 NOTL NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty N2 NOTL NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE N2 NOTL')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS N2 NOTL')
                elseif diffmodel==3
                    save('MOLE MS N2 NOTL')
                elseif diffmodel==4
                    save('MOLE Dusty N2 NOTL')
                end
            end
        elseif Tlswitch==1
                        if CONVswitch==0
                if diffmodel==1
                    save('MOLE WILKE N2 NOCONV')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS N2 NOCONV')
                elseif diffmodel==3
                    save('MOLE MS N2 NOCONV')
                elseif diffmodel==4
                    save('MOLE Dusty N2 NOCONV')
                end
            elseif CONVswitch==1
                if diffmodel==1
                    save('MOLE WILKE N2')
                elseif diffmodel==2
                    save('MOLE WILKE-BOS N2')
                elseif diffmodel==3
                    save('MOLE MS N2')
                elseif diffmodel==4
                    save('MOLE Dusty N2')
                end
                        end
        end
    end
end
end
end
end
 


