%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%
%%% Function that calculates the heat capacity of the gas mixture
%%%        KUMAR RANJAN ROUT, rout@nt.ntnu.no
%%% INPUT: y1, y2, y3, y4, y5, y6 mass fraction [-]
%%%        temperature [K]
%%% OUTPUT: CPg [J/kg K]
%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function CPg = Heat_capacity( y1, y2, y3, y4, y5, y6, T1 )

global CP  Ncomp N 


Tmatrix = [ ones(N,1)  T1   T1.^2   T1.^3 ];

for j = 1:Ncomp
    CPcomp(:,j) = Tmatrix*CP(j,:)';
end

% MASS base
%for j = 1:Ncomp
%   CPcomp(:,j) =CPcomp(:,j)./MMASS(j);
%end

Yy=[y1, y2, y3, y4, y5, y6];

CPg = sum( Yy.*CPcomp , 2 );




